SystemOrganization addCategory: #'Daliot-Roulette'!
SystemOrganization addCategory: #'Daliot-FileSync'!
SystemOrganization addCategory: #'Daliot-common'!
SystemOrganization addCategory: #Daliot!
SystemOrganization addCategory: #'Daliot-QuictSort'!
SystemOrganization addCategory: #'Daliot-Statisticals'!
SystemOrganization addCategory: #'Daliot-Painter'!
SystemOrganization addCategory: #'Daliot-Plot'!
SystemOrganization addCategory: #'Daliot-PseudoCollections'!
SystemOrganization addCategory: #'Daliot-Mapper'!

!Matrix methodsFor: '*Daliot' stamp: 'hjo 4/8/2008 11:35'!
canAccessAtRow: integer1 atColumn: integer2

	^(integer1 between: 1 and: self rowCount) and: [
		(integer2 between: 1 and: self columnCount)
		]! !

!Matrix methodsFor: '*Daliot' stamp: 'hjo 5/3/2008 10:24'!
columns

	^(1 to: self columnCount)
		collect: [:rowIndex| self atColumn: rowIndex ]! !

!Matrix methodsFor: '*Daliot' stamp: 'hjo 4/3/2008 15:34'!
insertDiagonal: anArray 

	| diagonalStream nondiagonalStream matrix |
	diagonalStream := anArray readStream.
	nondiagonalStream := contents readStream.
	matrix := self species rows: nrows columns: ncols+1.
	
	matrix indicesDo: [:ri :ci | matrix at: ri at: ci put: (ri=ci ifTrue:[diagonalStream next] ifFalse:[nondiagonalStream next]) ].
	^matrix! !

!Matrix methodsFor: '*Daliot' stamp: 'hjo 4/3/2008 15:15'!
readFromTextStream: aReadStream 

	self indicesDo: [ :ri :ci | self at: ri at: ci put: aReadStream nextNumberFromText ]! !

!ByteSymbol methodsFor: '*Daliot' stamp: 'hjo 4/8/2008 11:14'!
accessingBlock

	^[:each| each perform: self ]! !

!CompiledMethod class methodsFor: '*Daliot' stamp: 'hjo 4/10/2008 10:15'!
categoriesUsedFor: aByteSymbol 

	^((self allInstances select: [:each| each selector = aByteSymbol ])
		collect: [:each | each methodCategory ]) asBag
	
	! !

!CompiledMethod methodsFor: '*Daliot' stamp: 'hjo 4/10/2008 10:08'!
methodCategory

	^self methodClass organization categoryOfElement: self selector! !

!Number methodsFor: '*Daliot' stamp: 'hjo 3/23/2008 20:15'!
equals: aNumber

	"Ported from Dolphin 4.0 by Howard J. Oh"
	| max significantDifference |
	significantDifference := 1.0e-9.
	^(max := self abs max: aNumber abs) <= significantDifference
		or: [(self-aNumber) abs < (significantDifference * max)]! !

!Number methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 14:03'!
equals: trueNumber withError: errorNumber

	^(self - trueNumber) abs <= errorNumber! !

!Number methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 14:05'!
equals: trueNumber withRelativeError: errorNumber

	^(self relativeTo: trueNumber) <= errorNumber! !

!Number methodsFor: '*Daliot' stamp: 'hjo 3/24/2008 10:42'!
quoAndRem: aNumber

	^{self quo: aNumber . self rem: aNumber}! !

!Number methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 14:06'!
relativeTo: trueNumber

	^(self - trueNumber)/trueNumber
! !

Error subclass: #GaussianEliminationError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot'!

!WriteStream methodsFor: '*Daliot' stamp: 'hjo 6/24/2008 17:50'!
nextPutParenthesisAround: aBlockContext 

	self nextPutAll: '( '.
	aBlockContext value.
	self nextPutAll: ' )'! !

!UndefinedObject methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 10:23'!
senderChainIncludesSelector: aByteSymbol 

	^false! !

!String class methodsFor: '*Daliot' stamp: 'hjo 6/16/2008 11:32'!
createPasswordForHost: aByteString id: aByteString2 

	| h i l o |
	h := aByteString asArray.
	i := aByteString2 asArray.
	l := ($0 to: $z) select: [:each| each isAlphaNumeric ].
	o := String new writeStream.

	1 to: (h size max: i size) do: [ : x | 
		o nextPut: 
			( l atWrap: 
				(l indexOf: (h atWrap: x)) * (l indexOf: (i atWrap: x) ) 
			)  ].
	^o contents! !

!String class methodsFor: '*Daliot' stamp: 'hjo 3/27/2008 15:58'!
fromLines: anArray

	^self streamContents: [:stream |

		anArray 
			do: [:each| stream nextPutAll: each ]
			separatedBy: [ "Dolphin 4: stream nextPutAll: self lineDelimiter" stream cr ].

	]! !

!String methodsFor: '*Daliot' stamp: 'hjo 5/15/2008 09:43'!
lazyInitializationCode

	^String streamContents: [:stream|
		stream nextPutAll: self.
		stream nextPutAll: ' isNil ifTrue: [
		self '.
		stream nextPutAll: self.
		stream nextPutAll: ': <Initialization object here>
	].
	^'.
		stream nextPutAll: self
		]! !

!String methodsFor: '*Daliot' stamp: 'hjo 4/3/2008 10:30'!
lineFeedFiltered

	^self reject: [:character| character = Character lf ]! !

!String methodsFor: '*Daliot' stamp: 'hjo 3/27/2008 15:57'!
lines

	^self subStrings: '
'! !

!PositionableStream methodsFor: '*Daliot' stamp: 'hjo 3/24/2008 10:43'!
collection

	^collection! !

!PositionableStream methodsFor: '*Daliot' stamp: 'hjo 5/14/2008 16:18'!
nextSeparators

	| positionBeforeSkip positionAfterSkip |
	positionBeforeSkip := self position.
	self skipSeparators.
	positionAfterSkip := self position.
	self position: positionBeforeSkip.
	^self next: positionAfterSkip - positionBeforeSkip! !

!Integer methodsFor: '*Daliot' stamp: 'hjo 6/2/2008 19:31'!
combinationOutOf: anInteger

	^(self permutationOutOf: anInteger) / self factorial! !

!Integer methodsFor: '*Daliot' stamp: 'hjo 4/15/2008 17:23'!
copiesOf: anObject

	| copies |
	copies := Array new: self.
	1 to: self do: [:i|
		copies at: i put: anObject copy].
	^copies! !

!Integer methodsFor: '*Daliot' stamp: 'hjo 4/15/2008 17:23'!
deepCopiesOf: anObject

	| copies |
	copies := Array new: self.
	1 to: self do: [:i|
		copies at: i put: anObject deepCopy].
	^copies! !

!Integer methodsFor: '*Daliot' stamp: 'hjo 4/15/2008 17:23'!
evaluationsOf: aBlockClosure 
	
	|objects|
	objects := Array writeStream: self.
	self timesRepeat: [ objects nextPut: aBlockClosure value ].
	^objects contents! !

!Integer methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 16:11'!
exactDivisors

	|ed sq |
	ed := OrderedCollection new.
	sq := self sqrt truncated.
	sq squared = self ifTrue: [ed add: sq. sq := sq-1].
	sq to: 1 by: -1 do: [ :d |
		( self rem: d ) = 0
			ifTrue: [
				ed addFirst: d.
				ed addLast: self/d
			]
	].
	^ed asArray! !

!Integer methodsFor: '*Daliot' stamp: 'hjo 4/15/2008 17:23'!
instancesOf: aClass

	| instances |
	instances := Array new: self.
	1 to: self do: [:i|
		instances at: i put: aClass new].
	^instances! !

!Integer methodsFor: '*Daliot' stamp: 'hjo 4/17/2008 11:04'!
isPerfectNumber

	^self exactDivisors sum = (self + self)! !

!Integer methodsFor: '*Daliot' stamp: 'hjo 4/7/2008 12:21'!
isRelativelyPrimeTo: anInteger

	^(self gcd: anInteger) = 1! !

!Integer methodsFor: '*Daliot' stamp: 'hjo 4/26/2008 14:28'!
modular: anInteger 

	^self < 0 
		ifTrue: [(self abs / anInteger) ceiling * anInteger + self modular: anInteger]
		ifFalse: [self rem: anInteger]! !

!Integer methodsFor: '*Daliot' stamp: 'hjo 4/15/2008 18:27'!
permutationOutOf: anInteger

	|product|
	product := 1.
	anInteger - self  + 1 to: anInteger do: [:x| product := product * x].
	^product! !

!Integer methodsFor: '*Daliot' stamp: 'hjo 4/18/2008 09:49'!
positiveIntegerRoot: anInteger

	| sd primeFactors powers |
	sd := self standardDecomposition.
	primeFactors := sd asSet.
	powers := primeFactors collect: [:each| sd occurrencesOf: each ].
	(powers size = 1) ifFalse: [ self error: 'failed.' ].
	^primeFactors product raisedTo: powers anyOne / anInteger! !

!Integer methodsFor: '*Daliot' stamp: 'hjo 4/7/2008 14:59'!
primeFactors

	^self standardDecomposition asSet! !

!Integer methodsFor: '*Daliot' stamp: 'hjo 5/8/2008 13:17'!
ramanujan

	^(self to: 2 by: -1) inject: 1 into: [:f0 :n| ( (f0 * n) + 1 ) sqrt ]! !

!Integer methodsFor: '*Daliot' stamp: 'hjo 4/7/2008 14:57'!
standardDecomposition

	| sd d x |
	sd := Bag new.
	d := 2.
	x := self.

	[x >= d] whileTrue: [
		(x rem: d) = 0
			ifTrue: 
			[
				x := x / d.
				sd add: d
			]
			ifFalse:
			[
				d := d + 1
			]
	].
	^sd! !

!Integer methodsFor: '*Daliot' stamp: 'hjo 7/22/2008 20:01'!
timesCollect: aBlockContext 

	^Array streamContents: [ : stream |
		self timesRepeat: [ stream nextPut: aBlockContext value ]
	]! !

!OrderedCollection methodsFor: '*Daliot' stamp: 'hjo 5/6/2008 15:40'!
asArrayedCollection

	^self asArray! !

!OrderedCollection methodsFor: '*Daliot' stamp: 'hjo 6/12/2008 13:21'!
modify: aBlockContext 

	1 to: self size do: [:index| self at: index modify: aBlockContext ]! !

!OrderedCollection methodsFor: '*Daliot' stamp: 'hjo 4/15/2008 18:31'!
removeAtIndex: anInteger 

	^self remove: (self at: anInteger)! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 4/7/2008 16:16'!
allMultiplied

	^self inject: 1 into: [:product :each| product * each ]! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 7/11/2008 14:03'!
classHistogram

	| classes classSet |
	classes := self asArray collect: [: each | each class ].
	classSet := classes asSet.
	^classSet collect: [: class | class -> (classes occurrencesOf: class) ]! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 6/24/2008 13:47'!
collect: aBlockContext thatDoesNotCause: errorClass 

	^(Array streamContents: [ :stream |
		self do: [ : each | | errorMet value |
			errorMet := false.
			[ value := aBlockContext value: each ] on: errorClass do: [: exp | errorMet := true ].
			errorMet ifFalse: [ stream nextPut: value ].
			].
		]) as: self species! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 7/20/2008 16:32'!
collectBy: aByteSymbol 

	^self collect: aByteSymbol accessingBlock! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 7/14/2008 13:47'!
collectForMulitCollection: aBlockContext 

	^self collect: [: each | each collectForMulitCollection: aBlockContext ]! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 4/8/2008 14:06'!
collectWith: aByteSymbol 

	^self collect: aByteSymbol accessingBlock! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 14:10'!
commonDivisors

	^(self collect: [:integer| integer exactDivisors ]) intersection! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 4/27/2008 12:52'!
detect: aBlockClosure ifFound: ifFoundBlock ifNotFound: ifNotFoundBlock 

	| failedInFinding object |
	failedInFinding := false.
	object := self detect: aBlockClosure ifNone: [ failedInFinding := true ].

	^failedInFinding
		ifTrue: [ ifNotFoundBlock value ]
		ifFalse: [ ifFoundBlock value: object ]! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 4/27/2008 12:51'!
detectIndex: aBlockContext ifFound: aBlockContext2 ifNotFound: aBlockContext3 

	^self detect: aBlockContext 
		ifFound: [:object| aBlockContext2 value: (self indexOf: object)] 
		ifNotFound: aBlockContext3! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 5/16/2008 12:56'!
distinguishedBy: aBlockContext 

	^Distinction new
		selectingBlock: aBlockContext;
		putAll: self! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 7/14/2008 14:34'!
doForMulitCollection: aBlockContext depth: aSmallInteger 
	self shouldBeImplemented! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 7/14/2008 15:36'!
doForMulitCollection: aBlockContext printOn: aWriteStream depth: aSmallInteger 

	self do: [ : each | each doForMulitCollection: aBlockContext printOn: aWriteStream depth: aSmallInteger-1 ] separatedBy: [ aSmallInteger-1 timesRepeat: [ aWriteStream cr ]  ]! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 5/6/2008 14:14'!
elementsAsSet

	^self collect: [:each| each asSet ]! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 5/6/2008 14:14'!
equalElementsOfElementsTo: collectionOfCollection

	^self elementsAsSet equalElementsTo: collectionOfCollection elementsAsSet! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 5/6/2008 13:54'!
equalElementsTo: aCollection

	^self size = aCollection size and: [
	(self includesAllOf: aCollection) and: [
	aCollection includesAllOf: self ]]	! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 5/3/2008 12:42'!
groupBy: aBlockContext 

	| dictionary |
	dictionary := Dictionary new.
	self do: [:each| dictionary at: (aBlockContext value: each) add: each ].
	^dictionary! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 4/14/2008 23:51'!
harmonicMean

	^self size / (self collect: [:each| each reciprocal ]) sum! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 14:26'!
intersection

	| i |
	self revisit: 'This is reimplementation in Squeak. If you wanta better one, port it from Dolphin image.'.
	i := self first.
	self do: [:collection| i := i select: [:each| collection includes: each ] ].
	^i ! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 13:47'!
intersectionsWith: aRectangle 

	^(self collect: [:rectangle| rectangle intersect: aRectangle]) reject: [:rect| rect isEmpty ] ! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 6/2/2008 16:24'!
isConsecutiveIntegers

	| sortedIntegers |
	sortedIntegers := self asSortedCollection.
	^(sortedIntegers first to: sortedIntegers last) equalElementsTo: sortedIntegers
! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 4/8/2008 11:06'!
isRedundant

	^self asSet size ~= self size! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 4/15/2008 18:04'!
isSubcollectionOf: aCollection

	^aCollection includesAllOf: self! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 4/22/2008 22:00'!
isUnique

	| uni |
	uni := Set new.
	self do: [:each | (uni includes: each) ifTrue: [^false] ifFalse: [uni add: each ] ].
	^true! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 5/3/2008 12:50'!
keysAndValuesCollect: aBlockContext 

	^Array streamContents: [:stream|
		self keysAndValuesDo: [:key :value| stream nextPut: (aBlockContext value: key value: value)] ]! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 3/31/2008 19:43'!
maximumBy: accessingBlock

	^(self asSortedCollection: accessingBlock ascendingSortBlock) last! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 3/31/2008 19:47'!
minimumBy: accessingBlock

	^(self asSortedCollection: accessingBlock ascendingSortBlock) first! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 5/6/2008 15:22'!
minimumsBy: aByteSymbol 

	^MaxClub new
		evaluator: [:object| (aByteSymbol accessingBlock value: object) negated ];
		putAll: self;
		members! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 13:50'!
netArea

	^(self collect: [:shape| shape area ]) sum! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 4/18/2008 09:30'!
product

	^self inject: 1 into: [:p :each| p * each ]! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 4/1/2008 12:14'!
sameMembers: aCollection

	^self size = aCollection size and: [
	(self copyWithoutAll: aCollection) isEmpty and: [
	(aCollection copyWithoutAll: self) isEmpty ]]
! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 7/11/2008 15:04'!
sumEvenForEmpty

	^self isEmpty
		ifTrue: [ 0 ]
		ifFalse: [ self sum ]! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 6/28/2008 14:12'!
union

	| union |
	union := Set new.
	self do: [ : collection | union addAll: collection ].
	^union! !

!Interval methodsFor: '*Daliot-Mapper' stamp: 'hjo 7/29/2008 16:40'!
interPointOfRatio: aNumber

	^(self stop - self start) * aNumber + self start
! !

!Interval methodsFor: '*Daliot-Mapper' stamp: 'hjo 7/29/2008 16:40'!
interRatioOf: aNumber

	^(aNumber - self start)/(self stop - self start)
! !

!ReadStream methodsFor: '*Daliot' stamp: 'hjo 4/19/2008 07:48'!
nextAndSkipSeparators

	| object |
	object := self next.
	self skipSeparators.
	^object! !

!ReadStream methodsFor: '*Daliot' stamp: 'hjo 4/17/2008 12:35'!
nextNumberFromText

	[^Number readFrom: self ] ensure: [self skipSeparators]! !

!ReadStream methodsFor: '*Daliot' stamp: 'hjo 4/17/2008 12:22'!
nextSeparatedString

	[^self upToSeparator] ensure: [self skipSeparators]! !

!ReadStream methodsFor: '*Daliot' stamp: 'hjo 4/8/2008 09:51'!
nextSquareMatrixFromText

	| matrixSize  |
	matrixSize := self nextNumberFromText.
	^Matrix rows: matrixSize columns: matrixSize contents:
		(Array streamContents: [:contentsStream | 
			matrixSize squared timesRepeat: [ contentsStream nextPut: self nextNumberFromText ].
		]).
! !

!ReadStream methodsFor: '*Daliot' stamp: 'hjo 4/3/2008 15:56'!
upToSeparator

	| posWhenCalled posFound |
	posWhenCalled := self position.
	[self atEnd or: [self peek isSeparator]] whileFalse: [self skip:1].
	posFound := self position.
	self position: posWhenCalled.
	^self next: (posFound-posWhenCalled)! !

SequenceableCollection subclass: #CodeBook
	instanceVariableNames: 'codes codeLength multiQuoAndRem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-PseudoCollections'!

!CodeBook classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
of: aCollection length: anInteger

	^self new
		codes: aCollection;
		codeLength: anInteger;
		yourself
! !

!CodeBook methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 18:13'!
at: anInteger

	^((self multiQuoAndRem value: anInteger-1) copyToEndFrom: 2) collect: [:each| self codes at: each + 1 ]
	! !

!CodeBook methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
codeLength

	^codeLength! !

!CodeBook methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
codeLength: anInteger 

	multiQuoAndRem := nil.
	^codeLength := anInteger
! !

!CodeBook methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
codes

	^codes! !

!CodeBook methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
codes: anArray 

	multiQuoAndRem := nil.
	^codes := anArray! !

!CodeBook methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
multiQuoAndRem

	multiQuoAndRem isNil
		ifTrue:
			[multiQuoAndRem := MultiQuoAndRem new.
			multiQuoAndRem dividers: (self codeLength copiesOf: self codes size)
			].
	^multiQuoAndRem! !

!CodeBook methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
size

	^self codes size raisedTo: self codeLength! !

!CodeBook methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
species

	^Array! !

SequenceableCollection subclass: #Combinations
	instanceVariableNames: 'choices length'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-PseudoCollections'!

!Combinations commentStamp: 'hjo 6/2/2008 20:09' prior: 0!
this is total reimplementation of mathematical operation 'combination'.
this although the class names is same with my Dolphin implementation Combination, but its meaning is very different.
This squeak version is more true to mathematical definition.
!

!Combinations classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
example

	^self of: #($a $a $a $b $b) length: 5! !

!Combinations classSide methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 20:20'!
of: anArray

	^(anArray collect: [:each| self of: anArray length: each ]) concatenateAll! !

!Combinations classSide methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 20:19'!
of: anArray length: anInteger

	^self new choices: anArray; length: anInteger! !

!Combinations methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 20:21'!
asArrayedCollection

	^self asArray! !

!Combinations methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 20:05'!
at: anInteger

	| index |
	^self length = 1 
		ifTrue: [ {self choices at: anInteger} ]
		ifFalse: [ 
			index := anInteger.
			1 to: self choices size -1 
				do: [:each| | subCombination |
					subCombination := self subCombinationAtChoiceIndex: each. 
					index <= subCombination size 
						ifTrue: [^{self choices at: each}, (subCombination at: index)] 
						ifFalse: [index:=index-subCombination size]
			]
		]! !

!Combinations methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
choices

	^choices
! !

!Combinations methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 19:27'!
choices: anArray 

	choices := anArray! !

!Combinations methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
length

	^length
! !

!Combinations methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
length: anInteger 

	length := anInteger 
! !

!Combinations methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 19:30'!
size

	^self length combinationOutOf: self choices size! !

!Combinations methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
species

	^Array! !

!Combinations methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 20:00'!
subCombinationAtChoiceIndex: anInteger

	^self class of: (self choices copyToLastFrom: anInteger+1) length: self length-1! !

!Combinations methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 20:00'!
subCombinations

	^(1 to: self choices size-1) collect: [:each| 
		self subCombinationAtChoiceIndex: each
		]! !

SequenceableCollection subclass: #Permutations
	instanceVariableNames: 'choices length multiQuoAndRem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-PseudoCollections'!

!Permutations classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
of: anArray 

	^self of: anArray length: anArray size! !

!Permutations classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
of: aCollection length: anInteger

	^super new
		of: aCollection ;
		length: anInteger ;
		yourself! !

!Permutations methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
at: anInteger 

	| stream unchosen |
	stream := WriteStream on: (Array new: self length).
	unchosen := self choices copy.
	(self multiQuoAndRem indexValue: anInteger-1) do: [:each | stream nextPut: (unchosen removeAtIndex: each) ].
	^stream contents
	! !

!Permutations methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
choices

	^choices! !

!Permutations methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
length

	length isNil ifTrue: [ self length: self choices size ].
	^length! !

!Permutations methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
length: anInteger 

	multiQuoAndRem := nil.
	^length := anInteger! !

!Permutations methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
multiQuoAndRem

	multiQuoAndRem isNil 
		ifTrue:
		[ (multiQuoAndRem := MultiQuoAndRem new) dividers: (self choices size to: self choices size - self length + 1 by: -1) asArray ].
	^multiQuoAndRem! !

!Permutations methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
of: aCollection 

	multiQuoAndRem := nil.
	^choices := aCollection asOrderedCollection! !

!Permutations methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
size

	^self length permutationOutOf: self choices size! !

!Permutations methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
species

	^Array! !

!SequenceableCollection class methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 13:54'!
writeStream

	"Dolphin Method"
	^self new writeStream! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 8/12/2008 13:14'!
collectCouple: twoArgBlockClosure
	
	^Array streamContents: 
	[ :stream | 
		self doCouple: [:one :two| stream nextPut: (twoArgBlockClosure value: one value: two) ]
	]! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 19:16'!
concatenateAll

	^self concatenateAllSeparatedBy: self species new! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 5/6/2008 15:41'!
concatenateAllSeparatedBy: aCollection

	|stream|
	self isEmpty ifTrue: [^self species new].
	stream := self first asArrayedCollection species writeStream.
	self do: [:each| stream nextPutAll: each asArrayedCollection ] separatedBy: [stream nextPutAll: aCollection].
	^stream contents! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 7/9/2008 11:13'!
concatenateAllWithDoubleLineBreaks

	^self concatenateAllSeparatedBy:
'

'! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 15:40'!
copyFrom1ToSubCollectionIndexMinus1: anArray

	^self copyFrom: 1 to: (self indexOfSubCollection: anArray)-1! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/16/2008 16:40'!
copyFromFirstTo: anInteger 

	^self copyFrom: 1 to: anInteger! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/15/2008 18:14'!
copyToEndFrom: anInteger 

	^self copyFrom: anInteger to: self size! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/16/2008 16:41'!
copyToLastFrom: anInteger 

	^self copyFrom: anInteger to: self size! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/16/2008 17:24'!
copyToLastFromObject: anObject 

	^self copyToLastFrom: (self indexOf: anObject)! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/24/2008 11:45'!
copyWithoutLast

	^self copyFromFirstTo: self size-1! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/26/2008 11:10'!
detectIndex: aBlockContext 

	^self indexOf: (self detect: aBlockContext)! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 3/31/2008 08:55'!
do: aBlockClosure spanSize2: anInteger

	"Slower than #do:spanSize: , but better understandable."
	| span feeder |
	
	span := OrderedCollection withAll: (self copyTo: anInteger).
	feeder := (self copyFrom: anInteger+1) readStream.

	[ aBlockClosure value: span. feeder atEnd ]
	whileFalse: 
	[
		span removeFirst.
		span addLast: feeder next.
	]! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 18:41'!
do: aBlockClosure spanSize: anInteger

	|previousItems|

	anInteger-1 > self size ifTrue: [^self].
	previousItems := OrderedCollection withAll: (self copyFrom: 1 to: anInteger-1).
	anInteger to: self size do:
		[:i| previousItems addLast: (self at:i).
		aBlockClosure value: previousItems.
		previousItems removeFirst]! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 3/31/2008 08:54'!
doCouple: aBlockClosure

	self do: [:x| aBlockClosure value: x first value: x second] spanSize: 2
! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/13/2008 13:32'!
doRolled: aBlockClosure spanSize: anInteger 

	|previousItems|

	self size < anInteger ifTrue: [^self].
	previousItems := OrderedCollection withAll: (self copyFrom: self size - anInteger + 2).
	self do: [:each| 
		previousItems addLast: each. 
		aBlockClosure value: previousItems. 
		previousItems removeFirst ]! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 7/15/2008 10:54'!
dot: anArray

	"FASTER VERSION:"
	|sumForDot|
	self assert: [ self size = anArray size ].
	sumForDot := 0.
	1 to: self size do: [:i| sumForDot := (self at: i) * (anArray at: i) + sumForDot ].
	^sumForDot
	"SMART LOOKING VERSION:" 
	"^(self convolve: aVector) sum"
! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 5/10/2008 15:54'!
indexOfMaximum

	^self indexOfMaximumBy: #yourself! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 5/10/2008 15:59'!
indexOfMaximumBy: accessingSymbol 

	| maxClub |
	maxClub := MaxClub new evaluator: [:index| (self at: index) perform: accessingSymbol ].
	maxClub putAll: (1 to: self size).
	maxClub members size = 1 ifFalse: [ self error: 'not one maximum here.' ].
	^maxClub members anyOne! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/26/2008 11:00'!
indicesOf: anObject

	^(1 to: self size) select: [:each| (self at:each) = anObject]! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/16/2008 17:57'!
isInOrder

	| sortedSelf | 
	sortedSelf := self asSortedCollection.
	^(1 to: self size) allSatisfy: [:index| (sortedSelf at: index) = (self at: index) ]! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 7/15/2008 10:53'!
linearlyCombinatedBy: anArray

	^(self dot: anArray) / anArray sum! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/26/2008 11:18'!
merge1Prefix: aByteString 

	| index |
	index := self detectIndex: [:each| each = aByteString ].
	^(self copyFromFirstTo: index-1),
		{(self at: index) , (self at: index+1)},
		(self copyToLastFrom: index+2)! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/27/2008 12:48'!
mergePrefix: aByteString 

	^self detectIndex: [:each| each = aByteString ]
		ifFound: [ :index |
			(self copyFromFirstTo: index-1),
				{(self at: index) , (self at: index+1)},
				(self copyToLastFrom: index+2) ]
		ifNotFound: [ self ]! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/21/2008 12:12'!
multiDimensionalCollect2: aBlockContext 

	^self multiDimensionalCollect: [:each | aBlockContext valueWithArguments: each ]
! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 3/24/2008 12:20'!
multiDimensionalCollect: monoBlock 

	|stream|
	stream := self species writeStream.
	self multiDimensionalDo: [:sample| stream nextPut: (monoBlock value: sample) ].
	^stream contents! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/21/2008 12:11'!
multiDimensionalDo2: aBlockContext 

	^self multiDimensionalDo: [:each| aBlockContext valueWithArguments: each ]
! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 3/24/2008 12:37'!
multiDimensionalDo: monoBlock

	self isEmpty ifTrue: [^self].
	self size = 1 ifTrue: [^self first do: [:oneParam| monoBlock value: (Array with: oneParam)]].
	self first do: [:first| 
		(self copyFrom: 2 to: self size) multiDimensionalDo: [:paramWithoutFirst|
			monoBlock value: (Array with: first) , paramWithoutFirst
		]]! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/21/2008 12:15'!
multiDimensionalSelect2: aBlockContext 

	^Array streamContents: [:stream|
		self multiDimensionalDo: [:each| 
			(aBlockContext valueWithArguments: each)
				ifTrue: [stream nextPut: each]
			]
		]! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 6/30/2008 09:39'!
numbersEqualTo: anArray 

	self size = anArray size ifFalse: [ ^false ].
	
	^(1 to: anArray size) allSatisfy: [ : each |  (self at: each) equals: (anArray at: each) ]! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/23/2008 12:09'!
reverseAt: aSmallInteger 

	^self at: self size - aSmallInteger + 1! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 5/21/2008 18:47'!
reverseIndexOf: anObject
	
	self size to: 1 by: -1 do: [ :index| 
		(self at: index) = anObject ifTrue: [^index]
		].
	^0! !

!Symbol methodsFor: '*Daliot-common' stamp: 'hjo 3/17/2008 17:17'!
ascendingSortBlock

	^[:objectA :objectB | (objectA perform: self) < (objectB perform: self) ]! !

!Symbol methodsFor: '*Daliot-common' stamp: 'hjo 3/17/2008 17:22'!
descendingSortBlock

	^[:objectA :objectB | (objectA perform: self) > (objectB perform: self) ]! !

!PasteUpMorph methodsFor: '*Daliot' stamp: 'hjo 3/25/2008 18:05'!
collapseAllSystemWindows

	(self submorphs select: [:so| so class = SystemWindow ]) do: [: ow | ow collapse ]! !

!Rectangle class methodsFor: '*Daliot' stamp: 'hjo 7/15/2008 10:51'!
thatIncludesAllPoints: aCollection

	|xSort ySort|
	xSort := (aCollection collect: [:each| each x]) asSortedCollection.
	ySort := (aCollection collect: [:each| each y]) asSortedCollection.
	^Rectangle origin: xSort first@ySort first corner: xSort last@ySort last! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 09:25'!
canMergeEastWith: aRectangle 

	^self right = aRectangle left and: [ self topAndBottomIsSameWith: aRectangle ]! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 09:24'!
canMergeNorthWith: aRectangle 

	^self top = aRectangle bottom and: [ self leftAndRightIsSameWith: aRectangle ]! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 09:24'!
canMergeSouthWith: aRectangle 

	^self bottom = aRectangle and: [ self leftAndRightIsSameWith: aRectangle ]! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 09:24'!
canMergeWestWith: aRectangle 

	^self left = aRectangle right and: [ self topAndBottomIsSameWith: aRectangle ]! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 09:19'!
canMergeWith: aRectangle 

	^(self canMergeNorthWith: aRectangle) or: [
	(self canMergeSouthWith: aRectangle) or: [
	(self canMergeWestWith: aRectangle) or: [
	(self canMergeEastWith: aRectangle) ]]]
! !

!Rectangle methodsFor: '*Daliot-Mapper' stamp: 'hjo 7/29/2008 16:39'!
interPointOfRatio: aPoint

	^self extent * aPoint + self origin

! !

!Rectangle methodsFor: '*Daliot-Mapper' stamp: 'hjo 7/29/2008 16:39'!
interRatioOf: aPoint

	|extent displacement|
	extent := self extent.
	displacement := aPoint - origin.
	^(displacement x / extent x)@(displacement y / extent y)! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 13:49'!
isEmpty

	^(self width<= 0) or: [self height <= 0]! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 09:54'!
mergedEastWith: aRectangle 

	^ self left @ self top corner: aRectangle right @ aRectangle bottom! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 09:52'!
mergedWith: aRectangle 

	(self canMergeNorthWith: aRectangle) ifTrue: [^self mergedNorthWith: aRectangle].
	(self canMergeSouthWith: aRectangle) ifTrue: [^self mergedSouthWith: aRectangle].
	(self canMergeWestWith: aRectangle) ifTrue: [^self mergedWestWith: aRectangle].
	(self canMergeEastWith: aRectangle) ifTrue: [^self mergedEastWith: aRectangle]
! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 09:26'!
topAndBottomIsSameWith: aRectangle 

	^self top = aRectangle top and: [self bottom = aRectangle bottom ]! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 13:55'!
untruncatedCenter

	^(self origin + self corner)/2! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 10:05'!
xRange

	^Range close: self left open: self right! !

!ArrayedCollection methodsFor: '*Daliot' stamp: 'hjo 5/6/2008 15:41'!
asArrayedCollection

	^self! !

!ArrayedCollection methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 11:17'!
includesKey: anInteger 

	self isEmpty ifTrue: [^false].
	^anInteger between: 1 and: self size ! !

!ArrayedCollection methodsFor: '*Daliot' stamp: 'hjo 6/12/2008 09:23'!
modify: aBlockContext 

	1 to: self size do: [:index| self at: index modify: aBlockContext ]! !

!Random class methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 12:44'!
globalRandom

	^Smalltalk at: 'GlobalRandom' ifAbsentPut: [ Random new ]! !

Stream subclass: #RevolvingStream
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

!RevolvingStream classSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:49'!
on: aSequenceableCollection

	^self basicNew collection: aSequenceableCollection! !

!RevolvingStream methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:46'!
atEnd

	"Never ends"
	^false! !

!RevolvingStream methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:47'!
collection

	^self stream collection! !

!RevolvingStream methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:48'!
collection: aSequenceableCollection

	self stream: (ReadStream on: aSequenceableCollection)! !

!RevolvingStream methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:48'!
current

	^self collection at: self position! !

!RevolvingStream methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:48'!
isReadable

	^true! !

!RevolvingStream methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:48'!
isWriteable

	^false "Just for now it is."! !

!RevolvingStream methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:48'!
next

	self stream atEnd ifTrue: [ self stream reset ].
	^self stream next! !

!RevolvingStream methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:48'!
peek: anInteger 

	| positionBacked |
	positionBacked := self position.
	[ ^self next: anInteger ] ensure: [ self position: positionBacked ]! !

!RevolvingStream methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:48'!
position

	^self stream position! !

!RevolvingStream methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:48'!
position: anInteger

	self stream position: anInteger! !

!RevolvingStream methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:48'!
stream

	^stream! !

!RevolvingStream methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:49'!
stream: aStream

	stream := aStream! !

!BlockContext methodsFor: '*Daliot-common' stamp: 'hjo 3/17/2008 17:14'!
ascendingSortBlock

	self assert: [self argumentCount = 1].
	^[:objectA :objectB | (self value: objectA) < (self value: objectB) ]! !

!BlockContext methodsFor: '*Daliot-common' stamp: 'hjo 3/17/2008 17:21'!
descendingSortBlock

	self assert: [self argumentCount = 1].
	^[:objectA :objectB | (self value: objectA) > (self value: objectB) ]! !

!BlockContext methodsFor: '*Daliot' stamp: 'hjo 6/12/2008 12:55'!
ignoreError: aClass 
	
	^self on: aClass do: [:exception|  "do nothing" exception ]! !

!BlockContext methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 10:23'!
senderChainIncludesSelector: aByteSymbol 

	^ sender senderChainIncludesSelector: aByteSymbol ! !

!BlockContext methodsFor: '*Daliot' stamp: 'hjo 3/29/2008 21:39'!
valueAllWithArguments: anArray 

	^anArray collect: [:parameterArray|   self valueWithArguments: parameterArray ]! !

!BlockContext methodsFor: '*Daliot-common' stamp: 'hjo 3/18/2008 21:21'!
whileFalse: aBlockContext loopLimit: anInteger 

	|loopCount|
	loopCount := 0.
	self whileFalse: [aBlockContext value. loopCount := loopCount + 1. loopCount > anInteger ifTrue: [self error: 'Infinite loop suspected.' ] ]! !

!MethodContext methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 10:22'!
senderChainIncludesSelector: aByteSymbol 

	^sender selector = aByteSymbol or: [ sender senderChainIncludesSelector: aByteSymbol ]! !

TestRunner subclass: #DaliotsTestRunner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot'!

!DaliotsTestRunner methodsFor: 'accessing-classes' stamp: 'hjo 3/28/2008 11:22'!
browseUnsentMessages
| sentClasses methods  coveredMethods uncoveredMethods references |

	references := classesSelected gather: [ :class |
		class methodDict values , class class methodDict values gather: [ :method |
			(method literals copyWithoutAll: class allSelectors , class class allSelectors)
				select: [ :each | each isSymbol ] ] ].

	coveredMethods := OrderedCollection new.
	references
		do: [:each | coveredMethods addAll: (SystemNavigation new allImplementorsOf: each) ].
sentClasses := Smalltalk allClasses select: [:c| (c category = #EcologicalBinPacking) and: [ c superclass ~= TestCase ]].
	methods := OrderedCollection new.
	sentClasses do: [:ee| ee selectors do: [:ss| methods add: (MethodReference class:ee selector: ss) ]].

	coveredMethods := coveredMethods select: [:me| |class| class := Smalltalk at: me classSymbol. class category =  #EcologicalBinPacking].

	uncoveredMethods := methods copyWithoutAll: coveredMethods. 
	SystemNavigation new browseMessageList: uncoveredMethods name: 'Untested Methods' ! !

!DaliotsTestRunner methodsFor: 'accessing-classes' stamp: 'hjo 3/28/2008 11:16'!
classMenu: aMenu
	| menu |
	menu := aMenu
		title: 'Classes';
		yourself.
	self browserEnvironment notNil ifTrue: [ 
		menu
			add: 'Browse classes' action: #browseTestClasses;
			add: 'Browse referenced classes' action: #browseReferencedClasses ].
	^ menu
		add: 'Browse sent messages' action: #browseSentMessages;
		add: 'Browse unsent messages' action: #browseUnsentMessages;
		addLine;
		add: 'Select all' action: #selectAllClasses;
		add: 'Select subclasses' action: #selectSubclasses;
		add: 'Select inversion' action: #selectInverseClasses;
		add: 'Select none' action: #selectNoClasses;
		addLine;
		add: 'Filter...' action: #filterClasses;
		addLine;
		add: 'Refresh' action: #updateClasses;
		yourself.! !

!Point methodsFor: '*Daliot' stamp: 'hjo 4/13/2008 13:03'!
colinear: p1 with: p2

	^((self-p1) crossProduct: (self-p2)) = 0! !

!Point methodsFor: '*Daliot' stamp: 'hjo 4/10/2008 12:24'!
equals: aPoint 

	^(self x equals: aPoint x) and: [self y equals: aPoint y]! !

!Point methodsFor: '*Daliot' stamp: 'hjo 4/8/2008 12:56'!
pointRectangle

	^self corner: self copy! !

!Point methodsFor: '*Daliot' stamp: 'hjo 4/13/2008 08:09'!
polygonAreaKernel: backPoint with: forePoint

	^self y * (forePoint x - backPoint x)! !

!Point methodsFor: '*Daliot' stamp: 'hjo 4/10/2008 12:42'!
projectionPointTo: aPoint 

	^self projectionPointToUnitPoint: aPoint unitPoint! !

!Point methodsFor: '*Daliot' stamp: 'hjo 4/10/2008 12:26'!
projectionPointToUnitPoint: aPoint 

	^aPoint * (aPoint dotProduct: self)! !

!Point methodsFor: '*Daliot' stamp: 'hjo 4/10/2008 14:14'!
projectionTo: aPoint 

	^self dotProduct: aPoint unitPoint! !

!Point methodsFor: '*Daliot' stamp: 'hjo 4/10/2008 12:32'!
projectionToUnitPoint: aPoint 

	^self dotProduct: aPoint! !

!Point methodsFor: '*Daliot' stamp: 'hjo 4/10/2008 16:09'!
rotatedBy90Degrees

	^self y negated @ self x! !

!Point methodsFor: '*Daliot' stamp: 'hjo 4/10/2008 12:19'!
unitPoint

	^self / self r! !

TestCase subclass: #CodeBookTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-PseudoCollections'!

!CodeBookTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
testAccess

	|cb|
	cb := CodeBook new
		codes: #( $a 1 'hi' );
		codeLength: 5;
		yourself.

	self assert: cb size = (3 raisedTo: 5).
	self assert: ( cb at: 1 ) = #( $a $a $a $a $a ).
	self assert: ( cb at: 2 ) = #( $a $a $a $a 1 ).
	self assert: ( cb at: 3 ) = #( $a $a $a $a 'hi' ).
	self assert: ( cb at: 4 ) = #( $a $a $a 1 $a ).
	self assert: ( cb at: 5 ) = #( $a $a $a 1 1 ).
	self assert: ( cb at: 6 ) = #( $a $a $a 1 'hi' ).
	self assert: ( cb at: (3 raisedTo: 5) ) = #( 'hi' 'hi' 'hi' 'hi' 'hi' ).
! !

!CodeBookTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 18:05'!
testCollect

	| collected |
	collected := (CodeBook of: #( 10 1 ) length: 2) collect: [:each | each first + each second ].
	
	self 
		assert: collected size = 4;
		assert: ( collected includesAllOf: #( 2 11 20 ) )! !

!CodeBookTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
testSelect

	self assert: 
		((CodeBook of: #( false true ) length: 2) select: [:each | each first and: [each second] ]) size = 1! !

TestCase subclass: #CombinationsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-PseudoCollections'!

!CombinationsTest methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 19:21'!
test3c1

	self assert: ((Combinations of: 'abc' length: 1) equalElementsTo: #(#($a) #($b) #($c)))! !

!CombinationsTest methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 20:06'!
test3c2

	self assert: ((Combinations of: 'abc' length: 2) equalElementsTo: #(#($a $b) #($a $c) #($b $c)))! !

!CombinationsTest methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 19:42'!
test3c3

	self assert: ((Combinations of: 'abc' length: 3) equalElementsTo: #(#($a $b $c)))! !

TestCase subclass: #DaliotTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot'!

!DaliotTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/4/2008 19:17'!
testConcatenateAll

	self assertEquals: 'daysbikeDistancepushUpsdophinChangeLogSize' to: #('days' 'bikeDistance' 'pushUps' 'dophinChangeLogSize') concatenateAll.
	self assertEquals: #(1 2 3 4 10 11 12 13 14 15) to: {(1 to: 4). (10 to: 15)} concatenateAll.
	self assertEquals: (ByteArray withAll: #(50 10 20 100 110 120 200 220 250 254)) to: 
		(OrderedCollection new add: (ByteArray withAll: #(50 10 20));
		add: (ByteArray withAll: #(100 110 120));
		add: (ByteArray withAll: #(200 220 250 254));
		yourself) concatenateAll! !

!DaliotTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/4/2008 19:21'!
testConcatenateAllSeparatedBy

	self assertEquals: 'days bikeDistance pushUps dophinChangeLogSize' to: (#('days' 'bikeDistance' 'pushUps' 'dophinChangeLogSize') concatenateAllSeparatedBy: ' ').
	self assertEquals: #(1 2 3 4 $x 10 11 12 13 14 15) to: ({(1 to: 4) . (10 to: 15)} concatenateAllSeparatedBy: 'x').
	self assertEquals: (ByteArray withAll: #(50 10 20 1 2 3 100 110 120 1 2 3 200 220 250 254)) to: 
		((OrderedCollection new add: (ByteArray withAll: #(50 10 20));
		add: (ByteArray withAll: #(100 110 120));
		add: (ByteArray withAll: #(200 220 250 254));
		yourself) concatenateAllSeparatedBy: (ByteArray withAll: #(1 2 3)))! !

!DaliotTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/8/2008 13:08'!
testEqualityComparison

	| ec |
	ec := EqualityComparison new selectors: {#x . #y}.
	
	self assert: (ec of: 1@1 and: 1@1).
	self deny: (ec of: 1@2 and: 1@1).
	self deny: (ec of: 2@1 and: 1@1)! !

!DaliotTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/8/2008 17:39'!
testEqualityComparisonHashing

	| ec point |
	ec := EqualityComparison new selectors: {#x . #y}.
	point := 10@3.
	self assert: (ec hashOf: point) equals: (point x hash bitXor: point y hash) hash! !

!DaliotTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/16/2008 18:04'!
testInOrder

	self assert: 'abcd' isInOrder.
	self deny: 'acbd' isInOrder! !

!DaliotTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/26/2008 14:27'!
testModular

	self assert: (100 modular: 9) equals: 1.
	self assert: (-100 modular: 9) equals: 8! !

!DaliotTest methodsFor: 'point test' stamp: 'hjo 4/10/2008 16:10'!
testPointRotatedBy90Degrees

	self assert: (3@4) rotatedBy90Degrees equals: (-4 @ 3)! !

!DaliotTest methodsFor: 'point test' stamp: 'hjo 4/10/2008 12:19'!
testUnitPoint

	self assert: (3@4) unitPoint equals: (0.6 @ 0.8)! !

TestCase subclass: #FileSyncSideTest
	instanceVariableNames: 'o'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-FileSync'!

!FileSyncSideTest methodsFor: 'private' stamp: 'hjo 1/1/2008 23:20'!
answerForFullPathTest

	^'ab' , FileDirectory slash , 'cd'! !

!FileSyncSideTest methodsFor: 'running' stamp: 'hjo 1/1/2008 23:16'!
setUp

	super setUp.
	o := FileSyncSide new.
! !

!FileSyncSideTest methodsFor: 'testing' stamp: 'hjo 1/5/2008 01:19'!
testIsFolder

	o path: 'root'.
	o itemName: 'folder'.
	self assert: (o isFolderContext: nil)! !

!FileSyncSideTest methodsFor: 'testing' stamp: 'hjo 1/1/2008 23:20'!
testSyncSide

	o path: 'ab'.
	o itemName: 'cd'.
	self assert: o fullPath = self answerForFullPathTest! !

!FileSyncSideTest methodsFor: 'testing' stamp: 'hjo 1/1/2008 23:21'!
testSyncSide2

	o path: 'ab'.
	o itemName: FileDirectory slash , 'cd'.
	self assert: o fullPath = self answerForFullPathTest! !

!FileSyncSideTest methodsFor: 'testing' stamp: 'hjo 1/1/2008 23:29'!
testSyncSide3

	o path: 'ab' , FileDirectory slash.
	o itemName: 'cd'.
	self assert: o fullPath = self answerForFullPathTest! !

!FileSyncSideTest methodsFor: 'testing' stamp: 'hjo 1/1/2008 23:43'!
testSyncSide4

	o path: 'ab' , FileDirectory slash.
	o itemName: FileDirectory slash , 'cd'.
	self assert: o fullPath = self answerForFullPathTest! !

TestCase subclass: #FileSyncTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-FileSync'!

!FileSyncTest methodsFor: 'testing' stamp: 'hjo 1/1/2008 23:46'!
testDestinationSide

	| fs |
	fs := FileSync from: 'refe' to: 'des' for: 'ff'.
	self assert: fs destinationSide fullPath = ('des' , FileDirectory slash , 'ff').
	! !

!FileSyncTest methodsFor: 'testing' stamp: 'hjo 1/1/2008 23:09'!
testReferenceSide

	| fs |
	fs := FileSync from: 'refe' to: 'des' for: 'ff'.
	self assert: fs referenceSide fullPath = ('refe' , FileDirectory slash , 'ff').
	! !

TestCase subclass: #Line2DAbstractTestCase
	instanceVariableNames: 'line'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

Line2DAbstractTestCase subclass: #HalfLine2DTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

!HalfLine2DTestCase classSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 13:42'!
isAbstract

	^false! !

!HalfLine2DTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 13:43'!
answerForTestPoint1

	^false! !

!HalfLine2DTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 13:43'!
answerForTestPoint2

	^true! !

!HalfLine2DTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 13:43'!
answerForTestPoint3

	^true! !

!HalfLine2DTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 13:43'!
setUp

	super setUp.
	line := HalfLine2D startPoint: 0@1 direction: 2@1! !

!Line2DAbstractTestCase classSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 13:45'!
isAbstract

	^true! !

!Line2DAbstractTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 13:44'!
testPoint1

	self assert: (line includes: -2@0) = self answerForTestPoint1! !

!Line2DAbstractTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 13:44'!
testPoint2

	self assert: (line includes: 1@1.5) = self answerForTestPoint2! !

!Line2DAbstractTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 13:45'!
testPoint3

	self assert: (line includes: 4@3) = self answerForTestPoint3! !

Line2DAbstractTestCase subclass: #Line2DTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

!Line2DTestCase classSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 13:40'!
isAbstract

	^false! !

!Line2DTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 13:39'!
answerForTestPoint1

	^true! !

!Line2DTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 13:39'!
answerForTestPoint2

	^true! !

!Line2DTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 13:39'!
answerForTestPoint3

	^true! !

!Line2DTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 13:40'!
setUp

	super setUp.
	line := Line2D a: 1 b: -2 c: 2! !

Line2DAbstractTestCase subclass: #LineSegment2DTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

!LineSegment2DTestCase classSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 13:41'!
isAbstract

	^false! !

!LineSegment2DTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 13:40'!
answerForTestPoint1

	^false! !

!LineSegment2DTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 13:41'!
answerForTestPoint2

	^true! !

!LineSegment2DTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 13:41'!
answerForTestPoint3

	^false! !

!LineSegment2DTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 13:41'!
setUp

	super setUp.
	line := LineSegment2D point1: 0@1 point2: 2@2! !

TestCase subclass: #PermutationsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-PseudoCollections'!

!PermutationsTest methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 19:16'!
test3p1

	self assert: ((Permutations of: 'abc' length: 1) equalElementsTo: #(#($a) #($b) #($c)))! !

!PermutationsTest methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 19:17'!
test3p2

	self assert: ((Permutations of: 'abc' length: 2) equalElementsTo: #(#($a $b) #($a $c) #($b $a) #($b $c) #($c $a) #($c $b)))! !

!PermutationsTest methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 19:18'!
test3p3

	self assert: ((Permutations of: 'abc' length: 3) equalElementsTo: #(#($a $b $c) #($a $c $b) #($b $a $c) #($b $c $a) #($c $a $b) #($c $b $a)))! !

TestCase subclass: #PointProjectionTest
	instanceVariableNames: 'referencePoint point'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot'!

!PointProjectionTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/10/2008 16:00'!
setUp

	super setUp.
	point := 0@2.
	referencePoint := 4@3! !

!PointProjectionTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/10/2008 16:01'!
testProjectionPointTo

	self assert: (point projectionPointTo: referencePoint) equals: 0.96@0.72! !

!PointProjectionTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/10/2008 16:01'!
testProjectionPointToUnitPoint

	self assert: (point projectionPointToUnitPoint: referencePoint unitPoint) equals: 0.96@0.72! !

!PointProjectionTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/10/2008 14:10'!
testProjectionTo

	self assert: (point projectionTo: referencePoint) equals: 1.2! !

!PointProjectionTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/10/2008 15:50'!
testProjectionToUnitPoint

	self assert: (point projectionToUnitPoint: referencePoint unitPoint) equals: 1.2! !

TestCase subclass: #QuickSortTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-QuictSort'!

!QuickSortTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 12:57'!
test0

	self assertEquals: {} to: (QuickSort ascendingNumbers: {}) sorted.! !

!QuickSortTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 12:57'!
test1

	self assertEquals: {1} to: (QuickSort ascendingNumbers: {1}) sorted.! !

!QuickSortTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 12:58'!
test2

	self assertEquals: {1. 2} to: (QuickSort ascendingNumbers: {1. 2}) sorted.
	self assertEquals: {1. 2} to: (QuickSort ascendingNumbers: {2. 1}) sorted.! !

!QuickSortTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 13:10'!
test3

	self assertEquals: {1. 2. 3} to: (QuickSort ascendingNumbers: {1. 2. 3}) sorted.
	self assertEquals: {1. 2. 3} to: (QuickSort ascendingNumbers: {1. 3. 2}) sorted.
	self assertEquals: {1. 2. 3} to: (QuickSort ascendingNumbers: {2. 1. 3}) sorted.
	self assertEquals: {1. 2. 3} to: (QuickSort ascendingNumbers: {2. 3. 1}) sorted.
	self assertEquals: {1. 2. 3} to: (QuickSort ascendingNumbers: {3. 1. 2}) sorted.
	self assertEquals: {1. 2. 3} to: (QuickSort ascendingNumbers: {3. 2. 1}) sorted.
! !

!QuickSortTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 13:13'!
test4

	self assertEquals: {1. 2. 3. 4} to: (QuickSort ascendingNumbers: {1. 2. 3. 4}) sorted.
	self assertEquals: {1. 2. 3. 4} to: (QuickSort ascendingNumbers: {1. 2. 4. 3}) sorted.
	self assertEquals: {1. 2. 3. 4} to: (QuickSort ascendingNumbers: {1. 3. 2. 4}) sorted.
	self assertEquals: {1. 2. 3. 4} to: (QuickSort ascendingNumbers: {1. 3. 4. 2}) sorted.
	self assertEquals: {1. 2. 3. 4} to: (QuickSort ascendingNumbers: {1. 4. 2. 3}) sorted.
	self assertEquals: {1. 2. 3. 4} to: (QuickSort ascendingNumbers: {1. 4. 3. 2}) sorted.
	self assertEquals: {1. 2. 3. 4} to: (QuickSort ascendingNumbers: {4. 3. 2. 1}) sorted.
! !

!QuickSortTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 13:19'!
testDescending

	self assertEquals: {4. 3. 2. 1} to: (QuickSort descendingNumbers: {1. 2. 3. 4}) sorted.! !

!QuickSortTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 14:03'!
testSortBlock

	self assertEquals: #('do' 'cat' 'bear' 'anaconda') to:
		(QuickSort new sortBlock: [:a :b| a size < b size ];
			array: {'anaconda' . 'bear' . 'cat' . 'do'}) sorted! !

!QuickSortTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 13:18'!
testString

	self assertEquals: #('He' 'a' 'and' 'from' 'his' 'later' 'moving' 'on' 'perished' 'seat' 'thrown' 'train' 'was') to:
(QuickSort ascendingNumbers: 'He was later thrown from his seat on a moving train and perished' subStrings) sorted! !

TestCase subclass: #StatisticAgentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Statisticals'!

!StatisticAgentTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
testAccumulator

	| acc |
	acc := Accumulator new.
	self assertEquals: 0 to: acc sum.
	acc input: 10.
	self assertEquals: 10 to: acc sum.
	acc input: -20.
	self assertEquals: -10 to: acc sum.
	acc countUp.
	self assertEquals: -9 to: acc sum.
	acc countDown.
	self assertEquals: -10 to: acc sum.
! !

!StatisticAgentTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
testAverageAgent

	| av |
	av := AverageAgent new.
	self assertEquals: 0 to: av sum.
	av input: 10.
	self assertEquals: 10 to: av mean.
	av input: -20.
	self assertEquals: -5 to: av mean.
	av countUp.
	self assertEquals: -3 to: av mean.
	av countDown.
	self assertEquals: -5/2 to: av mean.
! !

!StatisticAgentTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
testAverageAgentNoAssertingMean

	| av |
	av := AverageAgent new.
	self assertEquals: 0 to: av noAssertingMean.
	self assertEquals: 0 to: av sum.
	av input: 10.
	self assertEquals: 10 to: av noAssertingMean.
	av input: -20.
	self assertEquals: -5 to: av noAssertingMean.
	av countUp.
	self assertEquals: -3 to: av noAssertingMean.
	av countDown.
	self assertEquals: -5/2 to: av noAssertingMean.

! !

!StatisticAgentTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
testMeanAndDeviationAgent

	| mada |
	mada := MeanAndDeviationAgent new.
	self assertEquals: 0 to: mada sum.
	mada input: 10.
	self assertEquals: 10 to: mada sum.
	self assertEquals: 10 to: mada mean.
	self assertEquals: 0 to: mada variance.
	self assertEquals: 0 to: mada standardDeviation.
	mada input: 10.
	self assertEquals: 20 to: mada sum.
	self assertEquals: 10 to: mada mean.
	self assertEquals: 0 to: mada variance.
	self assertEquals: 0 to: mada standardDeviation.
	mada input: 10.
	self assertEquals: 30 to: mada sum.
	self assertEquals: 10 to: mada mean.
	self assertEquals: 0 to: mada variance.
	self assertEquals: 0 to: mada standardDeviation.
	mada input: 0.
	self assertEquals: 30 to: mada sum.
	self assertEquals: 15/2 to: mada mean.
	self assertEquals: 75/4 to: mada variance.
	self assert: (mada standardDeviation equals: 4.33012701892219 withRelativeError: 0.0001).
! !

!StatisticAgentTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
testNonnegativeAccumulator

	| nacc |
	nacc := NonnegativeAccumulator new.
	self assertEquals: 0 to: nacc sum.
	nacc input: 100.
	self assertEquals: 100 to: nacc sum.
	nacc input: -10.
	self assertEquals: 90 to: nacc sum.
	self should: [nacc input: -100] raise: Error.
	nacc input: -10.
	self assertEquals: 80 to: nacc sum.! !

!TestCase methodsFor: '*Daliot-common' stamp: 'hjo 4/3/2008 09:47'!
assert: evaluated equals: expected

	expected = evaluated
		ifFalse: [ self signalFailure: 'expected: ' , expected printString , '  but was: ' , evaluated printString ]! !

!TestCase methodsFor: '*Daliot' stamp: 'hjo 5/6/2008 13:29'!
assert: evaluatedArray equalsArray: expectedArray

	self assert: (evaluatedArray includesAllOf: expectedArray).
	self assert: (expectedArray includesAllOf: evaluatedArray)
	! !

!TestCase methodsFor: '*Daliot-common' stamp: 'hjo 4/3/2008 09:45'!
assert: expected equalsTo: evaluated

	expected = evaluated
		ifFalse: [ self signalFailure: 'expected: ' , expected printString , '  but was: ' , evaluated printString ]! !

!TestCase methodsFor: '*Daliot-common' stamp: 'hjo 3/31/2008 08:46'!
assertEquals: expected to: evaluated

	expected = evaluated
		ifFalse: [ self signalFailure: 'expected: ' , expected printString , '  but was: ' , evaluated printString ]! !

!Dictionary methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 20:18'!
at: key add: element

	(self at: key ifAbsentPut: [OrderedCollection new]) add: element
	! !

!ByteString methodsFor: '*Daliot' stamp: 'hjo 5/14/2008 17:55'!
wordHighlightedStrings

	| index rangeStart rangeStop |
	index := 0.
	^self subStrings collect: [:subs|
		rangeStart := self indexOfSubCollection: subs startingAt: index.
		rangeStop := rangeStart + subs size - 1.
		index := rangeStop + 1.
		HighlightedString string: self rangeLeft: rangeStart rangeRight: rangeStop
		 ]! !

Object subclass: #Brush
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

!Brush commentStamp: 'hjo 7/25/2008 17:33' prior: 0!
Dolphin has Brush. Squeak does not. What is equivalent to Brush in Squeak?!

Object subclass: #DaliotUtility
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot'!

!DaliotUtility methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 09:45'!
classCategoriesNotCoveredByMonticello

	| all packageNames |
	all := SystemOrganizer allInstances anyOne categories.

	packageNames := MCWorkingCopy allInstances collect: [:each | each package name ].

	^all reject: [:ca| packageNames anySatisfy: [:pa| 
		ca beginsWith: pa
		]].
! !

!DaliotUtility methodsFor: 'as yet unclassified' stamp: 'hjo 5/18/2008 15:08'!
dabDateWmvUriFrom: aString

	| wmv index http |
	wmv := aString indexOfSubCollection: '.wmv'.

	index := 0.
	[index := aString indexOfSubCollection: 'http://' startingAt: index+1.

	index < wmv] whileTrue: [http := index].
	^aString copyFrom: http to: wmv+3 
! !

Object subclass: #Distinction
	instanceVariableNames: 'selectingBlock rejectedOnes seletedOnes selectedOnes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot'!

!Distinction methodsFor: 'put' stamp: 'hjo 5/16/2008 16:27'!
put: anObject

	((self selectingBlock value: anObject)
		ifTrue: [ self selectedOnes ]
		ifFalse: [ self rejectedOnes ])
		add: anObject! !

!Distinction methodsFor: 'put' stamp: 'hjo 5/16/2008 12:57'!
putAll: aCollection

	aCollection do: [:each| self put: each ] ! !

!Distinction methodsFor: 'accessing' stamp: 'hjo 5/16/2008 13:00'!
rejectedOnes
	rejectedOnes isNil ifTrue: [
		self rejectedOnes: OrderedCollection new
	].
	^rejectedOnes! !

!Distinction methodsFor: 'accessing' stamp: 'hjo 5/16/2008 13:00'!
rejectedOnes: anOrderedCollection 

	rejectedOnes := anOrderedCollection 
! !

!Distinction methodsFor: 'accessing' stamp: 'hjo 5/16/2008 16:28'!
selectedOnes
	selectedOnes isNil ifTrue: [
		self selectedOnes: OrderedCollection new
	].
	^selectedOnes! !

!Distinction methodsFor: 'accessing' stamp: 'hjo 5/16/2008 16:29'!
selectedOnes: anOrderedCollection 
	
	selectedOnes := anOrderedCollection 
! !

!Distinction methodsFor: 'accessing' stamp: 'hjo 5/16/2008 12:59'!
selectingBlock
	^selectingBlock! !

!Distinction methodsFor: 'accessing' stamp: 'hjo 5/16/2008 12:57'!
selectingBlock: aBlockContext 
	selectingBlock := aBlockContext ! !

Object subclass: #EqualityComparison
	instanceVariableNames: 'selectors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot'!

!EqualityComparison methodsFor: 'evaluating' stamp: 'hjo 5/27/2008 15:29'!
hashOf: anObject

	^(selectors inject: 0 into: [:hash :symbol| hash bitXor: (anObject perform: symbol) hash]) hash! !

!EqualityComparison methodsFor: 'evaluating' stamp: 'hjo 4/8/2008 13:05'!
of: object1 and: object2

	^selectors allSatisfy: [:symbol| (object1 perform: symbol) = (object2 perform: symbol) ]! !

!EqualityComparison methodsFor: 'accessing' stamp: 'hjo 4/8/2008 13:06'!
selectors: arrayOfSymbols

	selectors := arrayOfSymbols! !

Object subclass: #FileSync
	instanceVariableNames: 'referencePath fileName destinationPath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-FileSync'!

!FileSync classSide methodsFor: 'instance creation' stamp: 'hjo 1/1/2008 03:35'!
from: aByteString to: aByteString2 for: aByteString3 

	^self new
		referencePath: aByteString;
		destinationPath:aByteString2;
		fileName:aByteString3;
		yourself! !

!FileSync methodsFor: 'accessing' stamp: 'hjo 1/1/2008 03:26'!
destinationFile
	^FileDirectory on: destinationPath , FileDirectory slash , fileName! !

!FileSync methodsFor: 'accessing' stamp: 'hjo 1/1/2008 03:36'!
destinationPath: aByteString 
	destinationPath :=aByteString! !

!FileSync methodsFor: 'accessing' stamp: 'hjo 1/1/2008 23:48'!
destinationSide
	
	^FileSyncSide new
		path: destinationPath;
		itemName: fileName;
		yourself! !

!FileSync methodsFor: 'accessing' stamp: 'hjo 1/1/2008 03:37'!
fileName: aByteString 
	fileName :=aByteString! !

!FileSync methodsFor: 'creation' stamp: 'hjo 1/1/2008 02:20'!
init
	referencePath := 'refe'.
	destinationPath := 'des'.
	fileName := 'ff'! !

!FileSync methodsFor: 'accessing' stamp: 'hjo 1/1/2008 03:35'!
referencePath: aByteString 
	referencePath :=aByteString! !

!FileSync methodsFor: 'accessing' stamp: 'hjo 1/1/2008 23:11'!
referenceSide
	
	^FileSyncSide new
		path: referencePath;
		itemName: fileName;
		yourself! !

Object subclass: #FileSyncSide
	instanceVariableNames: 'path itemName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-FileSync'!

!FileSyncSide methodsFor: 'accessing' stamp: 'hjo 1/1/2008 23:42'!
fullPath

	^(path endsWithThese: FileDirectory slash)
		ifTrue: [self fullPathIfPathLastIsSlash]
		ifFalse: [self fullPathIfPathLastIsNotSlash]! !

!FileSyncSide methodsFor: 'accessing' stamp: 'hjo 1/1/2008 23:35'!
fullPathIfPathLastIsNotSlash

	^(itemName beginsWithThese: FileDirectory slash)
		ifTrue: [path , itemName]
		ifFalse: [path , FileDirectory slash , itemName]! !

!FileSyncSide methodsFor: 'accessing' stamp: 'hjo 1/1/2008 23:37'!
fullPathIfPathLastIsSlash

	^(itemName beginsWithThese: FileDirectory slash)
		ifTrue: [ path , itemName copyWithoutFirst ]
		ifFalse: [ path , itemName ]! !

!FileSyncSide methodsFor: 'accessing' stamp: 'hjo 1/1/2008 23:04'!
itemName: aString

	itemName :=aString! !

!FileSyncSide methodsFor: 'accessing' stamp: 'hjo 1/1/2008 23:03'!
path: aString

	path := aString! !

Object subclass: #HighlightedString
	instanceVariableNames: 'string range'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot'!

!HighlightedString classSide methodsFor: 'as yet unclassified' stamp: 'hjo 5/14/2008 17:33'!
string: aByteString rangeLeft: integer1 rangeRight: integer2 

	^self new
		string: aByteString;
		range: (Range close: integer1 close: integer2 )! !

!HighlightedString methodsFor: 'as yet unclassified' stamp: 'hjo 5/14/2008 17:50'!
highlightUppercased

	^self string keysAndValuesCollect: [:index :character| (self range includes: index) ifTrue: [character asUppercase] ifFalse: [character asLowercase ] ]! !

!HighlightedString methodsFor: 'as yet unclassified' stamp: 'hjo 5/14/2008 17:38'!
highlightedPart

	^String withAll: (((1 to: self string size) select: [:each| self range includes: each])
		collect: [:index| self string at: index])! !

!HighlightedString methodsFor: 'accessing' stamp: 'hjo 5/14/2008 17:35'!
range
	^range! !

!HighlightedString methodsFor: 'accessing' stamp: 'hjo 5/14/2008 17:33'!
range: aRange 
	range := aRange ! !

!HighlightedString methodsFor: 'accessing' stamp: 'hjo 5/14/2008 17:35'!
string
	^string! !

!HighlightedString methodsFor: 'accessing' stamp: 'hjo 5/14/2008 17:33'!
string: aByteString 
	string := aByteString 
! !

Object subclass: #IDontKnow
	instanceVariableNames: 's d stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-FileSync'!

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/6/2008 17:27'!
encodeMacDirectory: aFileDirectory

	^String streamContents: [:ssss | 
		self encodeMacDirectory: aFileDirectory on: ssss ]! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/6/2008 17:37'!
encodeMacDirectory: aFileDirectory on: pathStream

	aFileDirectory fullName = FileDirectory root fullName
		ifFalse: [ self encodeMacDirectory: aFileDirectory on: pathStream containingDirectory ].
		
	pathStream nextPutAll: FileDirectory slash.
	pathStream nextPutAll: (self encodeMacFileName: aFileDirectory fullName)! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/6/2008 00:35'!
encodeMacFileName: aString

	^String streamContents:
		[:encoded|
			aString
				do: [:char| 
					self assert: [(':' includes: char) not].
					('1234567890abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ-^{},+' includes: char) 
					ifTrue: [encoded nextPut: char ] 
					ifFalse: [
						char = $/ ifTrue: [encoded nextPut: $:] ifFalse: [encoded nextPut: $\; nextPut: char] ] ]	
		]

	! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/5/2008 06:01'!
go

	s entries do: [:e|
		e isDirectory
			ifTrue: [ self goDirectory: e ]
			ifFalse: [ self goFile: e  ] 
		 ].
	^self stream contents! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/6/2008 00:56'!
goDirectory: e 

	self streamMakeDir: e.
	(self subDir: e name)
		stream: self stream;
		go! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/6/2008 17:18'!
goFile: e

	self stream 
		nextPutAll: 'cp -p '; 
		nextPutAll: (self encodeMacFileName: s fullName);
		nextPutAll: FileDirectory slash;
		nextPutAll: (self encodeMacFileName:e name);
		space;
		nextPutAll: (self encodeMacFileName: d fullName);
		nextPutAll: ';';
		cr! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/5/2008 06:18'!
s: fd1 d: fd2

	s := fd1.
	d := fd2! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/5/2008 05:02'!
sp: s1 dp: s2

	s := FileDirectory on: s1.
	d := FileDirectory on: s2! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/5/2008 13:38'!
stream

	stream isNil ifTrue: 
		[stream := WriteStream on: ByteString new].
	^stream! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/5/2008 06:17'!
stream: aWriteStream

	stream := aWriteStream! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/6/2008 11:28'!
streamMakeDir: e
	
	{ 'mkdir '. self encodeMacFileName: (d fullName, FileDirectory slash, e name). ';' }
		do: [:part| self stream nextPutAll: part].
		
	self stream cr
! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/5/2008 06:19'!
subDir: aString

	^self class new
		s: (s directoryNamed: aString)
		d: (d directoryNamed: aString)! !

Object subclass: #LinearMapper
	instanceVariableNames: 'domainFrom rangeFrom mapRatio unmapRatio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot'!

!LinearMapper classSide methodsFor: 'as yet unclassified' stamp: 'hjo 6/10/2008 15:13'!
mapsDomainFrom: aSmallInteger to: aSmallInteger2 toRangeFrom: aSmallInteger3 to: aSmallInteger4 

	^self new
		domainFrom: aSmallInteger;
		rangeFrom: aSmallInteger3;
		mapRatio: (aSmallInteger4-aSmallInteger3) / (aSmallInteger2-aSmallInteger);
		setUnmapRatioFromMapRatio! !

!LinearMapper methodsFor: 'as yet unclassified' stamp: 'hjo 6/12/2008 09:08'!
domainFrom
	domainFrom! !

!LinearMapper methodsFor: 'accessing' stamp: 'hjo 6/10/2008 15:14'!
domainFrom: aSmallInteger 
	
	domainFrom := aSmallInteger 
! !

!LinearMapper methodsFor: 'as yet unclassified' stamp: 'hjo 6/12/2008 09:08'!
map: aFloat 
	
	^(aFloat - self domainFrom) * self mapRatio + self rangeFrom! !

!LinearMapper methodsFor: 'as yet unclassified' stamp: 'hjo 6/30/2008 14:56'!
mapAll: anArray

	^anArray collect: [ : each | self map: each ]! !

!LinearMapper methodsFor: 'accessing' stamp: 'hjo 6/12/2008 09:06'!
mapRatio
	^mapRatio! !

!LinearMapper methodsFor: 'accessing' stamp: 'hjo 6/12/2008 09:05'!
mapRatio: aSmallInteger 

	mapRatio := aSmallInteger 
! !

!LinearMapper methodsFor: 'accessing' stamp: 'hjo 6/12/2008 09:08'!
rangeFrom

	^rangeFrom! !

!LinearMapper methodsFor: 'accessing' stamp: 'hjo 6/12/2008 09:05'!
rangeFrom: aSmallInteger 

	rangeFrom := aSmallInteger ! !

!LinearMapper methodsFor: 'as yet unclassified' stamp: 'hjo 6/12/2008 09:06'!
setUnmapRatioFromMapRatio

	self unmapRatio: self mapRatio reciprocal! !

!LinearMapper methodsFor: 'as yet unclassified' stamp: 'hjo 6/12/2008 09:11'!
unmap: aSmallInteger 

	^(aSmallInteger - self rangeFrom) * self unmapRatio + self domainFrom! !

!LinearMapper methodsFor: 'accessing' stamp: 'hjo 6/12/2008 09:11'!
unmapRatio

	^unmapRatio! !

!LinearMapper methodsFor: 'accessing' stamp: 'hjo 6/12/2008 09:07'!
unmapRatio: aFraction 

	unmapRatio := aFraction ! !

Object subclass: #MapperAbstract
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Mapper'!

MapperAbstract subclass: #IntervalMapper
	instanceVariableNames: 'foreRatio backRatio domainStart rangeStart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Mapper'!

!IntervalMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:33'!
backRatio

	^backRatio! !

!IntervalMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:33'!
backRatio: aNumber 

	backRatio := aNumber

! !

!IntervalMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:33'!
domainStart

	^domainStart

! !

!IntervalMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:34'!
domainStart: aNumber

	domainStart := aNumber

! !

!IntervalMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:34'!
foreRatio

	^foreRatio

! !

!IntervalMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:34'!
foreRatio: aNumber

	foreRatio := aNumber

! !

!IntervalMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:34'!
from: domainInterval to: rangeInterval

	|rangeDiff domainDiff|
	rangeDiff := rangeInterval stop - rangeInterval start.
	domainDiff := domainInterval stop - domainInterval start.
	foreRatio := rangeDiff / domainDiff.
	backRatio := domainDiff / rangeDiff.

	rangeStart := rangeInterval start.
	domainStart := domainInterval start.

! !

!IntervalMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:34'!
map: aNumber

	^(aNumber - domainStart) * foreRatio + rangeStart

! !

!IntervalMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:34'!
mapSize: aNumber
	
	^aNumber * foreRatio

! !

!IntervalMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:34'!
rangeStart

	^rangeStart

! !

!IntervalMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:35'!
rangeStart: aNumber

	rangeStart := aNumber
! !

!IntervalMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:35'!
reversed

	^self class new
		foreRatio: self backRatio;
		backRatio: self foreRatio;
		domainStart: self rangeStart;
		rangeStart: self domainStart! !

!IntervalMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:35'!
unmap: aNumber

	^(aNumber - rangeStart) * backRatio + domainStart! !

!IntervalMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:35'!
unmapSize: aNumber

	^aNumber * backRatio! !

!MapperAbstract classSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:30'!
from: object1 to: object2

	^self new from: object1 to: object2

! !

!MapperAbstract classSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:31'!
icon

	"This method is for Dolphin Smalltalk.
	^Icon fromFile: 'icon\mapper.ico'"! !

!MapperAbstract methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:29'!
from: domain to: range

	self subclassResponsibility

! !

!MapperAbstract methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:29'!
map: key

	self subclassResponsibility
! !

!MapperAbstract methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:30'!
unmap: value

	self subclassResponsibility
! !

MapperAbstract subclass: #QuadrangleMapper
	instanceVariableNames: 'domainQuadrangle rangeQuadrangle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Mapper'!

!QuadrangleMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:31'!
from: quadrangle1 to: quadrangle2

	domainQuadrangle := quadrangle1.
	rangeQuadrangle := quadrangle2
! !

!QuadrangleMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:32'!
map: aPoint

	^rangeQuadrangle pointOfDivisionRatio: (domainQuadrangle divisionRatioOf: aPoint)

! !

!QuadrangleMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:32'!
unmap: aPoint

	^domainQuadrangle pointOfDivisionRatio: (rangeQuadrangle divisionRatioOf: aPoint)

! !

MapperAbstract subclass: #RectangleMapper
	instanceVariableNames: 'xMapper yMapper'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Mapper'!

!RectangleMapper classSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 14:50'!
new

	^super new initialize! !

!RectangleMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 14:48'!
foreRatio

	^self xMapper foreRatio @ self yMapper foreRatio! !

!RectangleMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 14:49'!
from: rect1 to: rect2

	xMapper from: (rect1 left to: rect1 right)  to: (rect2 left to: rect2 right).
	yMapper from: (rect1 top to: rect1 bottom) to: (rect2 top to: rect2 bottom)

! !

!RectangleMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 14:49'!
initialize

	super initialize.
	xMapper := IntervalMapper new.
	yMapper := IntervalMapper new.

! !

!RectangleMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 14:49'!
map: aPoint

	^(xMapper map: aPoint x)@(yMapper map: aPoint y)

! !

!RectangleMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 14:49'!
mapRectangle: aRectangle

	^(self map: aRectangle origin) corner: (self map: aRectangle corner)

! !

!RectangleMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 14:49'!
reversed

	^self class new 
		xMapper: self xMapper reversed;
		yMapper: self xMapper reversed

! !

!RectangleMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 14:49'!
unmap: aPoint

	^(xMapper unmap: aPoint x)@(yMapper unmap: aPoint y)

! !

!RectangleMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 14:49'!
unmapRectangle: aRectangle

	^(self unmap: aRectangle origin) corner: (self unmap: aRectangle corner)

! !

!RectangleMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 14:49'!
xMapper

	^xMapper

! !

!RectangleMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 14:49'!
xMapper: aIntervalMapper

	xMapper := aIntervalMapper

! !

!RectangleMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 14:50'!
yMapper

	^yMapper

! !

!RectangleMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 14:50'!
yMapper: aIntervalMapper

	yMapper := aIntervalMapper

! !

!Object methodsFor: '*Daliot' stamp: 'hjo 7/15/2008 10:48'!
arrayOfMe
	
	^Array with: self! !

!Object methodsFor: '*Daliot' stamp: 'hjo 7/14/2008 13:47'!
collectForMulitCollection: aBlockContext 

	^aBlockContext value: self! !

!Object methodsFor: '*Daliot' stamp: 'hjo 7/14/2008 15:37'!
doForMulitCollection: aBlockContext printOn: aWriteStream depth: aSmallInteger 

	aBlockContext value: self! !

!Object methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 10:32'!
haltFor: aByteSymbol 
	
	(thisContext senderChainIncludesSelector: aByteSymbol)
		ifTrue: [self halt]! !

!Object methodsFor: '*Daliot' stamp: 'hjo 4/17/2008 10:18'!
isAheadOf: anObject in: anArray 

	^(anArray indexOf: self) < (anArray indexOf: anObject)! !

!Object methodsFor: '*Daliot' stamp: 'hjo 4/3/2008 13:29'!
printOn: aStream tabLevel: anInteger

	aStream tab: anInteger.
	self printOn: aStream	! !

!Object methodsFor: '*Daliot' stamp: 'hjo 3/31/2008 09:51'!
printStringTabLevel: anInteger

	^String streamContents: [:stream| self printOn: stream tabLevel: anInteger ]! !

!Object methodsFor: '*Daliot' stamp: 'hjo 3/18/2008 18:45'!
revisit: aString

	"does nothing"! !

Object subclass: #Painter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Painter'!

!Painter commentStamp: 'hjo 7/29/2008 16:45' prior: 0!
"FOLLOWING IS THE CODES FROM DOLPHIN SMALLTALK NOT COMPILED TO THIS SQUEAK IMAGE."

View subclass: #PainterView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!!
BufferedView subclass: #BufferedPainterView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!!









!!PainterView methodsFor!!

model: anObject

	super model: anObject.
	anObject when: #valueChanged send: #refresh to: self!!

onPaintRequired: aPaintEvent

	self model notNil 
		ifTrue:
		[ self model drawOn: aPaintEvent canvas rectangle: self clientRectangle ]!!

onPositionChanged: aPositionEvent

	super onPositionChanged: aPositionEvent.
	aPositionEvent isResize ifTrue: [self invalidate]!! !!

!!PainterView class methodsFor!!

standard

	^self new show
		clientExtent: 300@300;
		beTopMost!! !!




!!BufferedPainterView methodsFor!!

model: anObject

	super model: anObject.
	anObject when: #valueChanged send: #refresh to: self!!

updateBuffer: aCanvas

	(self model notNil and: [ self clientExtent isZero not ])
		ifTrue:
		[ self model drawOn: aCanvas rectangle: self clientRectangle ]!! !!

!!BufferedPainterView class methodsFor!!

standard

	^self new show
		clientExtent: 300@300;
		beTopMost!! !!

 


!

Painter subclass: #CirclePainter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Painter'!

!CirclePainter methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 15:06'!
drawOn: aCanvas rectangle: aRectangle

	| center radius |
	center := aRectangle center.
	radius := ((aRectangle width min: aRectangle height) * 0.9 / 2).

	aCanvas ellipse: (Rectangle center: center truncated extent: (radius @ radius) * 2) truncated! !

Painter subclass: #Plot2DPainter
	instanceVariableNames: 'space2D objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

!Plot2DPainter classSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:32'!
mathematical

	|inst|
	inst := self new.
	inst space2D domainRectangle: (-1@1 corner: 1@-1).
	^inst! !

!Plot2DPainter methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:28'!
addAllObjects: aCollection

	aCollection do: [:obj| self objects add: obj ].
	self trigger: #valueChanged! !

!Plot2DPainter methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:28'!
addObject: anObject

	self objects add: anObject.
	self trigger: #valueChanged! !

!Plot2DPainter methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:29'!
centerOfObjects

	^(self objects collect: [:each| each center]) asArray mean! !

!Plot2DPainter methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:29'!
domainCenter: aPoint 

	self pan: aPoint - self space2D domainRectangle untruncatedCenter! !

!Plot2DPainter methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:29'!
drawOn: aCanvas rectangle: aRectangle

	self space2D viewPortRectangle: aRectangle.
	self space2D drawOn: aCanvas.
	self objects do: [:each | each drawOn: aCanvas space2d: self space2D ]! !

!Plot2DPainter methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:29'!
object: anObject

	self removeAllObjects.
	self addObject: anObject! !

!Plot2DPainter methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:29'!
objects

	objects isNil ifTrue: [ self objects: OrderedCollection new ].
	^objects! !

!Plot2DPainter methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:29'!
objects: aCollection

	objects := aCollection asOrderedCollection! !

!Plot2DPainter methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:30'!
pan: aPoint 

	self space2D domainRectangle: (self space2D domainRectangle moveBy: aPoint).
	self trigger: #valueChanged! !

!Plot2DPainter methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:30'!
panAndZoomToObjects

	self panToCenterOfObjects.
	self zoomToIncludeAllObjects! !

!Plot2DPainter methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:30'!
panToCenterOfObjects

	self pan: (self centerOfObjects - self space2D domainRectangle untruncatedCenter)! !

!Plot2DPainter methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:30'!
removeAllObjects

	objects := nil! !

!Plot2DPainter methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:30'!
removeObject: anObject 

	self objects remove: anObject.
	self trigger: #valueChanged! !

!Plot2DPainter methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:30'!
setDomainRectangleToIncludeAllObjects

	| newRectangle |
	newRectangle := Rectangle thatIncludesAllRectangles: (self objects collect: [:each| each rectangle ]).
	(self space2D domainRectangle isUpsideDown and: [ newRectangle isUpsideDown not ])
		ifTrue: [ newRectangle := newRectangle upsideDown ].
	self space2D domainRectangle: newRectangle.
	self trigger: #valueChanged! !

!Plot2DPainter methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:30'!
setDomainRectangleToIncludeAllObjectsIgnoreErrors
	
	[^self setDomainRectangleToIncludeAllObjects] ignoreError! !

!Plot2DPainter methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:31'!
space2D

	space2D isNil ifTrue: [ self space2D: Space2D new ].
	^space2D! !

!Plot2DPainter methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:31'!
space2D: aSpace2D

	space2D := aSpace2D! !

!Plot2DPainter methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:31'!
zoom: aNumber

	self space2D domainRectangle: (self space2D domainRectangle magnifiedBy: aNumber@aNumber).
	self trigger: #valueChanged! !

!Plot2DPainter methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:31'!
zoomIn

	self zoom: 1/2! !

!Plot2DPainter methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:31'!
zoomOut

	self zoom: 2! !

!Plot2DPainter methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:31'!
zoomToIncludeAllObjects

	| newRectangle |
	newRectangle := Rectangle thatIncludesAllRectangles: (self objects collect: [:each| each rectangle ]).
	newRectangle := self space2D domainRectangle magnifiedToIncludeAllPoints: newRectangle cornerPoints.
	(self space2D domainRectangle isUpsideDown and: [ newRectangle isUpsideDown not ])
		ifTrue: [ newRectangle := newRectangle upsideDown ].
	self space2D domainRectangle: newRectangle.
	self trigger: #valueChanged! !

Painter subclass: #StarPainter
	instanceVariableNames: 'n'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Painter'!

!StarPainter methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 15:06'!
drawOn: aCanvas rectangle: aRectangle

	| center radius delta angle block |
	center := aRectangle center.
	radius := (aRectangle width min: aRectangle height) * 0.9 / 2.

	delta := (2 * Float pi / self points) * 2.
	angle := 0.

	block := [:a| ( (a sin @ a cos negated) * radius + center ) truncated ].

	aCanvas  moveTo: (block value: angle).
	self points timesRepeat: [ angle := angle + delta.  aCanvas  lineTo: (block value: angle) ].
! !

!StarPainter methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 15:07'!
points

	n isNil ifTrue: [ n := 5 ].
	^n! !

!StarPainter methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 15:07'!
points: anInteger

	n even ifTrue: [ self error: 'Odd Integers only.' ].
	^n := anInteger! !

Object subclass: #PainterDeco
	instanceVariableNames: 'painter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Painter'!

PainterDeco subclass: #BigDeco
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Painter'!

!BigDeco methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 15:08'!
drawOn: aCanvas rectangle: aRectangle 

	^self painter drawOn: aCanvas rectangle: (aRectangle expandRectangle: aRectangle)! !

!PainterDeco methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 15:05'!
painter

	^painter! !

!PainterDeco methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 15:05'!
painter: aPainter 

	^painter := aPainter! !

PainterDeco subclass: #RedDeco
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Painter'!

!RedDeco methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 15:24'!
drawOn: aCanvas rectangle: aRectangle 

	aCanvas pen: (Pen color: Color red).
	^self painter drawOn: aCanvas rectangle: aRectangle! !

PainterDeco subclass: #SmallDeco
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Painter'!

!SmallDeco methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 15:24'!
drawOn: aCanvas rectangle: aRectangle 

	^self painter drawOn: aCanvas rectangle: (aRectangle scaleBy: 0.5)! !

Object subclass: #Plot2DObject
	instanceVariableNames: 'pen'
	classVariableNames: 'PenColorStream'
	poolDictionaries: ''
	category: 'Daliot-Plot'!

Plot2DObject subclass: #Centered2DObject
	instanceVariableNames: 'center'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

!Centered2DObject methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:32'!
center

	center isNil ifTrue: [ self center: 0 @ 0 ].
	^center! !

!Centered2DObject methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:33'!
center: aPoint

	^self new center: aPoint! !

!Centered2DObject methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:33'!
color

	^self pen color! !

!Centered2DObject methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:33'!
color: aColor

	self pen color: aColor! !

!Centered2DObject methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:33'!
detailsStringForSmallVisionList

	center isNil ifTrue: [ ^'no center' ].
	^center printString! !

Centered2DObject subclass: #Circle2D
	instanceVariableNames: 'radius'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

!Circle2D classSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:34'!
center: aPoint radius: aNumber

	^self new
		center: aPoint;
		radius: aNumber! !

!Circle2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:32'!
basicDrawOn: aCanvas space2d: aSpace2D 

	| brush |
	brush := aCanvas brush.
	aCanvas brush: Brush transparent.
	aCanvas ellipse: (aSpace2D mapper mapRectangle: self rectangle) truncated.
	aCanvas brush: brush! !

!Circle2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:34'!
radius

	radius isNil ifTrue: [ self radius: 1 ].
	^radius! !

!Circle2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:34'!
radius: aNumber

	radius := aNumber! !

!Circle2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:34'!
rectangle

	^Rectangle origin: self center - self radius corner: self center + self radius! !

Centered2DObject subclass: #Point2DAbstract
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

!Point2DAbstract methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 13:46'!
- aPoint2D

	^self asPoint - aPoint2D asPoint! !

!Point2DAbstract methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 13:47'!
asPoint

	^self center! !

!Point2DAbstract methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 13:47'!
dist: aPoint2DAbstract

	^self center dist: aPoint2DAbstract center! !

!Point2DAbstract methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 13:47'!
setAsModelOfSubPresenterInSmallVisionShell: aSmallVisionShell

	self setAsModel: self center ofSubPresenter: aSmallVisionShell pointPresenter! !

!Point2DAbstract methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 13:47'!
typeStringForSmallVisionShellList

	^'point'! !

!Point2DAbstract methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 13:47'!
x

	^self center x! !

!Point2DAbstract methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 13:47'!
x: aNumber

	self center x: aNumber! !

!Point2DAbstract methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 13:47'!
y
	
	^self center y! !

!Point2DAbstract methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 13:48'!
y: aNumber

	self center y: aNumber! !

Point2DAbstract subclass: #Point2DCircle
	instanceVariableNames: 'radius'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

!Point2DCircle methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 13:46'!
basicDrawOn: aCanvas space2d: aSpace2D 

	| brush |
	brush := aCanvas brush.
	aCanvas brush: Brush transparent.
	aCanvas circle: (aSpace2D mapper map: self center) truncated radius: self radius truncated.
	aCanvas brush: brush
! !

!Point2DCircle methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 13:46'!
radius

	radius isNil ifTrue: [ radius := 5 ].
	^radius! !

!Point2DCircle methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 13:46'!
radius: aNumber

	radius := aNumber! !

Point2DAbstract subclass: #Point2DCross
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

!Point2DCross methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:36'!
basicDrawOn: aCanvas space2d: aSpace2D 

	| brush |
	brush := aCanvas brush.
	aCanvas cross: (Rectangle center:(aSpace2D mapper map: self center) extent: 8@8) truncated.
	aCanvas brush: brush! !

Plot2DObject subclass: #DaliotsPolygon
	instanceVariableNames: 'points'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

!DaliotsPolygon classSide methodsFor: 'instance creation' stamp: 'hjo 7/15/2008 10:48'!
points: anArray 

	^self new points: anArray! !

!DaliotsPolygon methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 06:52'!
area

	| acc |
	acc := Accumulator new.
	self points doRolled: [:threePoints| acc input: (threePoints second polygonAreaKernel: threePoints first with: threePoints third) ] spanSize: 3.
	^acc sum abs / 2! !

!DaliotsPolygon methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2008 18:52'!
asMorphicPolygon

	^PolygonMorph vertices: self points color: Color green borderWidth: 1 borderColor: Color red! !

!DaliotsPolygon methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:42'!
basicDrawOn: aCanvas space2d: aSpace2D 

	|stream|
	self points size >= 2
		ifTrue: [
	stream := self points readStream.
	aSpace2D moveTo: stream next on: aCanvas.
	[stream atEnd] whileFalse: [	aSpace2D lineTo: stream next on: aCanvas].
	aSpace2D lineTo: self points first on: aCanvas]! !

!DaliotsPolygon methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 06:52'!
center

	^self rectangle untruncatedCenter! !

!DaliotsPolygon methodsFor: 'as yet unclassified' stamp: 'hjo 7/15/2008 10:52'!
centerOfMass

	^self points size = 3
		ifTrue: [ Triangle2D new a: self points first; b: self points second; c: self points third; centerOfMass ]
		ifFalse: [|halfIndex polygons areas centers|
			halfIndex := (self points size / 2) truncated.
			polygons := (Array with: (self points copyFromFirstTo: halfIndex) with: (self points copyFrom: halfIndex), self points first arrayOfMe)
				collect: [:ps| self species points: ps ].
			areas := polygons collect: [:poly| poly area ].
			centers := polygons collect: [:poly| poly center ].
			centers linearlyCombinatedBy: areas
		]! !

!DaliotsPolygon methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:18'!
containsPoint: aPoint

	^DaliotsPolygon new points: self points; containsPoint: aPoint! !

!DaliotsPolygon methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 06:52'!
convexValues

	|crossSigns|
	crossSigns := Array writeStream: self points size.
	self points 
		doRolled: [:threePoints| 
			crossSigns nextPut: 
				((threePoints first-threePoints second) crossProduct: 
				(threePoints third-threePoints second)) sign ]
		spanSize: 3.
	^crossSigns contents! !

!DaliotsPolygon methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 18:05'!
isConcave

	^self convexValues asSet includesAllOf: #(-1 1)! !

!DaliotsPolygon methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 06:52'!
points

	points isNil ifTrue: [points := OrderedCollection new].
	^points! !

!DaliotsPolygon methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 06:52'!
points: anArray 

	points := anArray! !

!DaliotsPolygon methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 06:52'!
rectangle

	^Rectangle thatIncludesAllPoints: self points! !

Plot2DObject subclass: #Line2DAbstract
	instanceVariableNames: 'a b c'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

Line2DAbstract subclass: #HalfLine2D
	instanceVariableNames: 'startPoint direction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

!HalfLine2D classSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:38'!
startPoint: sPoint direction: dPoint

	^self new
		startPoint: sPoint;
		direction: dPoint! !

!HalfLine2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:36'!
direction

	^direction! !

!HalfLine2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:36'!
direction: aPoint 

	super reset.
	direction := aPoint! !

!HalfLine2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:36'!
includes: aPoint 

	^(super includes: aPoint) and: [(aPoint-self startPoint) sign = self direction sign]! !

!HalfLine2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:37'!
includingPoint

	^self startPoint! !

!HalfLine2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:37'!
startPoint

	^startPoint! !

!HalfLine2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:37'!
startPoint: aPoint 

	super reset.
	startPoint := aPoint! !

!HalfLine2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:37'!
twoPointsForDrawingLine: aSpace2D

	^((self crossPointsOnBoundariesOfSpace2D: aSpace2D) 
		asSortedCollection: [:point | point dist: self startPoint ] ascendingSortBlock)
			add: self startPoint;
			yourself! !

Line2DAbstract subclass: #Line2D
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

!Line2D classSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:40'!
a: number1 b: number2 c: number3

	^self new
		a: number1;
		b: number2;
		c: number3! !

!Line2D classSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:40'!
point1: aPoint point2: aPoint2 

	^self new setAbFromDirection: (aPoint - aPoint2); setCToInclude: aPoint! !

!Line2D classSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:40'!
x: aNumber

	^self new
		a: -1;
		b: 0;
		c: aNumber! !

!Line2D classSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:40'!
y: aNumber

	^self new
		a: 0;
		b: -1;
		c: aNumber! !

!Line2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:38'!
a

	self assert: [ a notNil ].
	^a! !

!Line2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:38'!
b

	self assert: [ b notNil ].
	^b! !

!Line2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:39'!
c

	self assert: [ c notNil ].
	^c! !

!Line2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:39'!
footOfPerpendicularFromPoint: aPoint

	^(self perpendicularIncluding: aPoint)
		crossPoint: self! !

!Line2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:39'!
perpendicularIncluding: aPoint

	^self class new
		a: b negated;
		b: a;
		setCToInclude: aPoint;
		yourself
! !

!Line2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:39'!
setCToInclude: aPoint

	self c: ((self a * aPoint x) + (self b * aPoint y)) negated! !

!Line2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:39'!
twoPointsForDrawingLine: aSpace2D

	^self crossPointsOnBoundariesOfSpace2D: aSpace2D! !

!Line2DAbstract methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:45'!
a

	a isNil ifTrue: [ self initializeAbc ].
	^a! !

!Line2DAbstract methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:45'!
a: aNumber

	a := aNumber! !

!Line2DAbstract methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:45'!
b

	b isNil ifTrue: [ self initializeAbc ].
	^b! !

!Line2DAbstract methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:45'!
b: aNumber

	b := aNumber! !

!Line2DAbstract methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:46'!
basicDrawLineSegmentOn: aCanvas space2D: aSpace2D fromPoints: anArray 

	anArray size >= 2
		ifTrue:  [
			(aCanvas mappedCanvas: aSpace2D mapper)
				moveTo: anArray first;
				lineTo: anArray last]! !

!Line2DAbstract methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:46'!
basicDrawOn: aCanvas space2d: aSpace2D 

	self basicDrawLineSegmentOn: aCanvas space2D: aSpace2D fromPoints: (self twoPointsForDrawingLine: aSpace2D)! !

!Line2DAbstract methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:46'!
c

	c isNil ifTrue: [ self initializeAbc ].
	^c! !

!Line2DAbstract methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:46'!
c: aNumber

	c := aNumber! !

!Line2DAbstract methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:46'!
crossPoint: anObject

	|cp|
	cp := [anObject crossPointWithLine2D: self] on: GaussianEliminationError do: [:exp| ^nil ].
	^((self includes: cp) and: [anObject includes: cp])
		ifTrue: [cp] ifFalse: [nil]! !

!Line2DAbstract methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:47'!
crossPointWithLine2D: aLine2D 

	^(((Matrix ofRows: (Array with: self matrixRow with: aLine2D matrixRow)) gaussianProcessed: 2)
		columnAt: 3) asPoint! !

!Line2DAbstract methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:47'!
crossPointsOnBoundariesOfSpace2D: aSpace2D

	^(aSpace2D domainBoundaryLineSegments
		collectNonError:[ :each| self crossPoint: each ])
			select: [:point| point notNil ]! !

!Line2DAbstract methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:47'!
includes: aPoint

	^0.0 equalsTo: (self a * aPoint x) + (self b * aPoint y) + self c! !

!Line2DAbstract methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:47'!
initializeAbc

	a := self direction y.
	b := self direction x negated.
	c := ((a * self includingPoint x) + (b * self includingPoint y)) negated! !

!Line2DAbstract methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:48'!
matrixRow

	^Array with: self a with: self b with: self c negated! !

!Line2DAbstract methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:49'!
reset

	a := nil.
	b := nil.
	c := nil! !

!Line2DAbstract methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:49'!
setAbFromDirection: aPoint

	a := aPoint y.
	b := aPoint x negated! !

!Line2DAbstract methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:49'!
setAsModelOfSubPresenterInSmallVisionShell: aSmallVisionShell 

	self setAsModelOfSubPresenter: aSmallVisionShell linePresenter! !

!Line2DAbstract methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:49'!
xAtY: aNumber

	^(b * aNumber + c) / a negated! !

!Line2DAbstract methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:49'!
yAtX: aNumber

	^(a * aNumber + c) / b negated! !

Line2DAbstract subclass: #LineSegment2D
	instanceVariableNames: 'point1 point2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

!LineSegment2D classSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:43'!
point1: aPoint point2: aPoint2 

	^self new point1: aPoint; point2: aPoint2! !

!LineSegment2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:40'!
= aLineSegment2D

	
	^aLineSegment2D isLineSegment and: [(self point1 = aLineSegment2D point1
	and: [ self point2 = aLineSegment2D point2 ])
	or:
	[self point1 = aLineSegment2D point2
	and: [ self point2 = aLineSegment2D point1 ]]]
! !

!LineSegment2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:41'!
basicDrawOn: aCanvas space2d: aSpace2D 

	(aCanvas mappedCanvas: aSpace2D mapper)
		moveTo: self point1;
		lineTo: self point2! !

!LineSegment2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:41'!
center

	^(self point1 + self point2)/2! !

!LineSegment2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:41'!
crossPointExcludingEndPoints: aLineSegment2D 

	|xp|
	xp := self crossPoint: aLineSegment2D.
	^(xp isNil or: [(xp equals: self point1) or: [xp equals: self point2]])
		ifTrue: [nil]
		ifFalse: [xp]
! !

!LineSegment2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:41'!
detailsStringForSmallVisionList

	^String writeStream
		print: self point1;
		nextPut: $,;
		print: self point2;
		contents! !

!LineSegment2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:41'!
direction

	^self point2 - self point1! !

!LineSegment2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:41'!
hash

	^(self point1 hash + self point2 hash) hash! !

!LineSegment2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:42'!
includes: aPoint 

	^(super includes: aPoint) and: 
		[ |s1 s2|
			s1 := (self point1 - aPoint) sign.
			s2 := (self point2 - aPoint) sign.
			0@0 = s1 or: [0@0 = s2 or: [0@0 = (s1+s2)]]]! !

!LineSegment2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:42'!
includingPoint

	^self point1! !

!LineSegment2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:42'!
isLineSegment 

	^true! !

!LineSegment2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:42'!
length

	^self point1 dist: self point2! !

!LineSegment2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:42'!
point1

	^point1! !

!LineSegment2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:42'!
point1: aPoint 

	super reset.
	point1 := aPoint! !

!LineSegment2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:42'!
point2

	^point2! !

!LineSegment2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:42'!
point2: aPoint 

	super reset.
	point2 := aPoint! !

!LineSegment2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:42'!
typeStringForSmallVisionShellList

	^'line segment'! !

!Plot2DObject classSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:18'!
penColorStream

	PenColorStream isNil ifTrue: 
		[
			self penColorStream: 
				(RevolvingStream on: 
					(OrderedCollection new 
						add: Color darkBlue;
						add: Color darkCyan;
						add: Color darkGreen;
						add: Color darkMagenta;
						add: Color darkRed;
						add: Color red;
						add: Color green;
						add: Color blue;
						add: Color cyan;
						add: Color magenta;
						add: Color brown;
						yourself)) 
		].
	^PenColorStream! !

!Plot2DObject classSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:18'!
penColorStream: aRevolvingStream 

	PenColorStream := aRevolvingStream ! !

!Plot2DObject methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:56'!
detailsStringForSmallVisionList

	^''! !

!Plot2DObject methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:56'!
drawOn: aCanvas space2d: aSpace2D 

	| penSaved |
	penSaved := aCanvas pen: self pen.
	self basicDrawOn: aCanvas space2d: aSpace2D.
	aCanvas pen: penSaved.! !

!Plot2DObject methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:56'!
flashIn: aPlot2DPainter 

	|operations|
	operations := Array 
		with: [aPlot2DPainter addObject: self] 
		with: [SessionManager inputState pumpMessages]
		with: [(Delay forMilliseconds: 500) wait]
		with: [aPlot2DPainter removeObject: self].
	(aPlot2DPainter objects includes: self)
		ifTrue: [operations swap: 1 with: 4].

	operations do: [:block| block value ]	! !

!Plot2DObject methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:56'!
isCharacterRecognizer

	^false! !

!Plot2DObject methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:56'!
isLineSegment 

	^false! !

!Plot2DObject methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:56'!
isRectangle 

	^false! !

!Plot2DObject methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:56'!
pen

	pen isNil ifTrue: [ self pen: (Pen color: self class penColorStream next) ].
	^pen! !

!Plot2DObject methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:56'!
pen: aPen

	pen := aPen! !

!Plot2DObject methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 14:09'!
setAsModel: anObject ofSubPresenter: aPresenter 

	aPresenter model: anObject.
	aPresenter view show zOrderTop! !

!Plot2DObject methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 14:09'!
setAsModelOfSubPresenter: aPresenter 

	self setAsModel: self ofSubPresenter: aPresenter ! !

!Plot2DObject methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 14:09'!
setAsModelOfSubPresenterInSmallVisionShell: aSmallVisionShell 

	aSmallVisionShell statusPresenter view show zOrderTop 
		text: self typeStringForSmallVisionShellList! !

!Plot2DObject methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 14:09'!
thickenPenIfIncludedIn: anArray 

	self pen: (Pen color: self pen color width: ((anArray includes: self) ifTrue:[3] ifFalse:[1]))! !

!Plot2DObject methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 14:09'!
typeStringForSmallVisionShellList

	^'plot 2d object'! !

Plot2DObject subclass: #Rectangle2D
	instanceVariableNames: 'rectangle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

Rectangle2D subclass: #Image2D
	instanceVariableNames: 'image'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

!Image2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:43'!
basicDrawOn: aCanvas space2d: aSpace2D

	| mappedRectangle |
	mappedRectangle := aSpace2D mapper mapRectangle: self rectangle.
	image drawOn: aCanvas at: mappedRectangle origin truncated extent: mappedRectangle extent truncated! !

!Image2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:43'!
detailsStringForSmallVisionList

	image isNil ifTrue: [ ^'no file' ].
	rectangle isNil ifTrue: [ ^'no rectangle' ].
	^rectangle extent printString! !

!Image2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:44'!
image

	^image! !

!Image2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:44'!
image: anImage

	image := anImage.
	self trigger: #valueChanged! !

!Image2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:44'!
isRectangle 

	^false! !

!Image2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:44'!
setRectanglePixelwise

	self rectangle: self image rectangle! !

!Image2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:44'!
typeStringForSmallVisionShellList

	^'image'! !

!Rectangle2D classSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:52'!
point1: aPoint point2: aPoint2 

	^self new rectangle: (aPoint corner: aPoint2)! !

!Rectangle2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:51'!
basicDrawOn: aCanvas space2d: aSpace2D 

	aCanvas transparentRectangle: (aSpace2D mapper mapRectangle: self rectangle) truncated! !

!Rectangle2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:51'!
center

	^self rectangle center! !

!Rectangle2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:51'!
detailsStringForSmallVisionList

	rectangle isNil ifTrue: [ ^'no rectangle' ].
	^String writeStream 
		print: rectangle origin;
		nextPut: $,;
		nextPut: $(;
		print: rectangle extent;
		nextPut: $);
		contents! !

!Rectangle2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:51'!
isRectangle 

	^true! !

!Rectangle2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:51'!
rectangle

	^rectangle! !

!Rectangle2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:51'!
rectangle: aRectangle 

	rectangle := aRectangle.
	self trigger: #valueChanged! !

!Rectangle2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:51'!
setAsModelOfSubPresenterInSmallVisionShell: aSmallVisionShell 

	self setAsModel: self rectangle ofSubPresenter: aSmallVisionShell rectanglePresenter! !

!Rectangle2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:52'!
typeStringForSmallVisionShellList

	^'box'! !

Plot2DObject subclass: #Triangle2D
	instanceVariableNames: 'a b c ab bc ca'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

Triangle2D subclass: #HironakasTriangle
	instanceVariableNames: 'd e bd ce'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

!HironakasTriangle methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:44'!
a: aPoint 

	super a: aPoint.
	self d: nil.
	self e: nil! !

!HironakasTriangle methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:45'!
ab: aPoint

	super ab: aPoint.
	self e: nil! !

!HironakasTriangle methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:45'!
b: aPoint 

	super b: aPoint.
	self d: nil.
	self e: nil.! !

!HironakasTriangle methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:45'!
bd

	bd isNil ifTrue: [bd := LineSegment2D point1: self b point2: self d].
	^bd! !

!HironakasTriangle methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:45'!
bd: aPoint

	bd := aPoint! !

!HironakasTriangle methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:45'!
c: aPoint 

	super c: aPoint.
	self d: nil.
	self e: nil! !

!HironakasTriangle methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:45'!
ca: aPoint

	self d: nil.
	super ca: aPoint! !

!HironakasTriangle methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:45'!
ce

	ce isNil ifTrue: [ce := LineSegment2D point1: self c point2: self e].
	^ce! !

!HironakasTriangle methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:45'!
ce: aPoint

	ce := aPoint! !

!HironakasTriangle methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:45'!
d

	d isNil ifTrue: [d := self ca crossPoint: self halfLineThatHalfsAngleB].
	^d! !

!HironakasTriangle methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:46'!
d: aPoint

	self bd: nil.
	d := aPoint! !

!HironakasTriangle methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:46'!
e

	e isNil ifTrue: [e:= self ab crossPoint: self halfLineThatHalfsAngleC].
	^e! !

!HironakasTriangle methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:46'!
e: aPoint

	self ce: nil.
	e := aPoint! !

!Triangle2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/23/2008 14:46'!
a

	self assert: [a notNil].
	^a! !

!Triangle2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/23/2008 14:46'!
a: aPoint 

	self ab: nil.
	self ca: nil.
	a := aPoint! !

!Triangle2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/23/2008 14:46'!
ab

	ab isNil ifTrue: [ab := LineSegment2D point1: self a point2: self b].
	^ab! !

!Triangle2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:31'!
ab: aLineSegment2D

	ab := aLineSegment2D! !

!Triangle2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/23/2008 14:47'!
area

	^DaliotsPolygon points: (Array with: self a with: self b with: self c) area! !

!Triangle2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/23/2008 14:47'!
b

	self assert: [b notNil].
	^b! !

!Triangle2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/23/2008 14:47'!
b: aPoint 

	self ab: nil.
	self bc: nil.
	b := aPoint! !

!Triangle2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/23/2008 14:47'!
basicDrawOn: aCanvas space2d: aSpace2D 

	(Array with: self ab with: self bc with: self ca)
		do: [:line| line basicDrawOn: aCanvas space2d: aSpace2D ]! !

!Triangle2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/23/2008 14:48'!
bc

	bc isNil ifTrue: [bc := LineSegment2D point1: self b point2: self c].
	^bc! !

!Triangle2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:31'!
bc: aLineSegment2D

	bc := aLineSegment2D! !

!Triangle2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/23/2008 14:48'!
c

	self assert: [c notNil].
	^c! !

!Triangle2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/23/2008 14:48'!
c: aPoint 

	c := aPoint.
	self ca: nil.
	self bc: nil.! !

!Triangle2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/23/2008 14:48'!
ca

	ca isNil ifTrue: [ca := LineSegment2D point1: self c point2: self a].
	^ca! !

!Triangle2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 17:31'!
ca: aLineSegment2D

	ca := aLineSegment2D! !

!Triangle2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/23/2008 14:48'!
centerOfMass

	^(Line2D point1: (self b + self c) / 2 point2: self a) crossPoint: 	(Line2D point1: (self c + self a) / 2 point2: self b)! !

!Triangle2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/23/2008 14:49'!
directionPointThatHalfsAngleB

	^(self a - self b) unit + (self c - self b) unit! !

!Triangle2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/23/2008 14:49'!
directionPointThatHalfsAngleC

	^(self a - self c) unit + (self b - self c) unit! !

!Triangle2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/23/2008 14:49'!
halfLineThatHalfsAngleB

	^HalfLine2D startPoint: self b direction: self directionPointThatHalfsAngleB! !

!Triangle2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/23/2008 14:49'!
halfLineThatHalfsAngleC

	^HalfLine2D startPoint: self c direction: self directionPointThatHalfsAngleC! !

Object subclass: #QuickSort
	instanceVariableNames: 'array sortBlock pivot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-QuictSort'!

!QuickSort classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 12:32'!
ascendingNumbers: anArray

	^self new array: anArray ; sortBlock: [ :a :b | a < b]! !

!QuickSort classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 13:19'!
descendingNumbers: anArray 

	^self new array: anArray ; sortBlock: [ :a :b | a > b]! !

!QuickSort classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 12:32'!
example1

	^self ascendingNumbers: {3 . 2 . 4 . 9 . 1 . 8 . 7 . 5 . 6 }! !

!QuickSort classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 12:33'!
example2

	^self ascendingNumbers: {}! !

!QuickSort classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 12:33'!
example3

	^self ascendingNumbers: {1}! !

!QuickSort classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 12:33'!
example4

	^self ascendingNumbers: {1. 2}! !

!QuickSort classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 12:33'!
example5

	^self ascendingNumbers: {2. 1}! !

!QuickSort classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 12:33'!
example6

	^self ascendingNumbers: {3. 2. 1}! !

!QuickSort methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 13:58'!
array: aSequenceableCollection

	array := aSequenceableCollection! !

!QuickSort methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 11:58'!
sortBlock: aBlock

	sortBlock := aBlock! !

!QuickSort methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 13:41'!
sorted

	array size <= 1 ifTrue: [^array copy ].
	array size = 2 ifTrue: [
		^(sortBlock value: array first value: array second) 
			ifTrue: [array copy]
			ifFalse: [{array second. array first}]
	].
	^self sortedDivideAndConquer! !

!QuickSort methodsFor: 'as yet unclassified' stamp: 'hjo 6/10/2008 14:28'!
sortedDivideAndConquer

	| parts |
	parts := QuickSortPart new
		array: array
		pivot: array atRandom
		sortBlock: sortBlock.
	^(self copy array: parts falses) sorted ,
	(self copy array: parts trues) sorted! !

Object subclass: #QuickSortPart
	instanceVariableNames: 'trues falses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-QuictSort'!

!QuickSortPart methodsFor: 'as yet unclassified' stamp: 'hjo 6/10/2008 14:25'!
array: anArray pivot: anObject sortBlock: aBlock

	|t f|
	t := Array new writeStream.
	f := Array new writeStream.
	anArray do: [ :each | 
		((aBlock value: anObject value: each)
			ifTrue: [t]
			ifFalse: [f]) nextPut: each ].
	trues := t contents.
	falses := f contents.
	
	self handleEmptyArrays: anObject! !

!QuickSortPart methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 13:32'!
falses

	^falses! !

!QuickSortPart methodsFor: 'as yet unclassified' stamp: 'hjo 6/10/2008 14:25'!
handleEmptyArrays: anObject 

	self handleEmptyTrues: anObject.
	self handleEmptyFalses: anObject.! !

!QuickSortPart methodsFor: 'as yet unclassified' stamp: 'hjo 6/10/2008 14:20'!
handleEmptyFalses: anObject 

	falses isEmpty ifTrue: [
		falses := { anObject }.
		trues := trues copyWithout: anObject
		].! !

!QuickSortPart methodsFor: 'as yet unclassified' stamp: 'hjo 6/10/2008 14:20'!
handleEmptyTrues: anObject

	trues isEmpty ifTrue: [
		trues := { anObject }.
		falses := falses copyWithout: anObject
		].! !

!QuickSortPart methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2008 13:32'!
trues

	^trues! !

Object subclass: #RangeMapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

Object subclass: #Roulette
	instanceVariableNames: 'slots'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Roulette'!

!Roulette methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 18:54'!
add: anObject area: aNumber

	self slots add: (RouletteSlot area: aNumber subject: anObject)! !

!Roulette methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 19:05'!
areaSum

	^(slots collect: [:slot|slot area]) sum! !

!Roulette methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 19:05'!
areaSum: aNumber

	|scale|
	scale :=  aNumber / self areaSum.
	slots do: [:slot| slot area: slot area * scale]! !

!Roulette methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 19:05'!
ball: aNumber

	^(self ballAndLocalBall: aNumber) first! !

!Roulette methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 19:04'!
ballAndLocalBall: aNumber

	|searchKey|
	searchKey := aNumber.
	slots do: [:slot| searchKey <= slot area ifTrue: [^Array with: slot subject with: searchKey] ifFalse: [searchKey := searchKey - slot area]].
	self error: 'Wide off the board'! !

!Roulette methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 19:05'!
localBall: aNumber

	^(self ballAndLocalBall: aNumber) second! !

!Roulette methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 19:06'!
remove: anObject

	slots remove: (slots detect: [:sl| sl subject == anObject])! !

!Roulette methodsFor: 'accessing' stamp: 'hjo 6/2/2008 19:02'!
slots
	
	slots isNil ifTrue: [ 
		self slots: (SortedCollection sortBlock: #area descendingSortBlock)
	].
	^slots! !

!Roulette methodsFor: 'accessing' stamp: 'hjo 6/2/2008 19:03'!
slots: aSortedCollection
	
	slots := aSortedCollection! !

Object subclass: #RouletteSlot
	instanceVariableNames: 'area subject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Roulette'!

!RouletteSlot classSide methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 18:58'!
area: aNumber subject: anObject

	^self new area: aNumber; subject: anObject! !

!RouletteSlot methodsFor: 'accessing' stamp: 'hjo 6/2/2008 19:03'!
area
	^area! !

!RouletteSlot methodsFor: 'accessing' stamp: 'hjo 6/2/2008 18:59'!
area: aNumber

	area := aNumber! !

!RouletteSlot methodsFor: 'accessing' stamp: 'hjo 6/2/2008 19:04'!
subject

	^subject! !

!RouletteSlot methodsFor: 'accessing' stamp: 'hjo 6/2/2008 18:59'!
subject: anObject

	subject := anObject! !

Object subclass: #SSTrainer
	instanceVariableNames: 'history delta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot'!

!SSTrainer methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:40'!
delta

	delta isNil ifTrue: [ self delta: {1 . 1 . 1 . 1} ].
	^delta! !

!SSTrainer methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:39'!
delta: anArray

	delta := anArray! !

!SSTrainer methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:38'!
history

	history isNil ifTrue: [ self history: (OrderedCollection with: (SquareSum new)) ].
	^history! !

!SSTrainer methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:38'!
history: anOrderedCollection

	history := anOrderedCollection! !

!SSTrainer methodsFor: 'looping' stamp: 'hjo 4/7/2008 09:50'!
step

	| champion challenger |
	champion := self history last.
	
	challenger := ( champion variationsWithDelta: self delta ) minimumBy: #e.
	
	champion e > challenger e
		ifTrue: [ self history addLast: challenger ]
		ifFalse: [ self delta: self delta / 2 ]
	
	! !

!SSTrainer methodsFor: 'looping' stamp: 'hjo 4/7/2008 09:52'!
step: anInteger

	anInteger timesRepeat: [self step]! !

Object subclass: #Space2D
	instanceVariableNames: 'xAxis yAxis'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

!Space2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:19'!
domainBoundaryLineSegments

	|rect|
	rect := self domainRectangle.
	^Array 
		with: (LineSegment2D point1: rect topLeft point2: rect topRight)
		with: (LineSegment2D point1: rect bottomLeft point2: rect bottomRight)
		with: (LineSegment2D point1: rect topLeft point2: rect bottomLeft)
		with: (LineSegment2D point1: rect topRight point2: rect bottomRight)

! !

!Space2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:19'!
domainBoundaryLines: lineClass

	^
		(self yAxis domainBoundaryLines: lineClass instanciationMethod: #y:),
	 	(self xAxis domainBoundaryLines: lineClass instanciationMethod: #x:)! !

!Space2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:19'!
domainRectangle

	^(self xAxis domain start @ self yAxis domain start) corner: (self xAxis domain stop @ self yAxis domain stop)! !

!Space2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:20'!
domainRectangle: aRectangle

	self xAxis domain: (Range close: aRectangle left close: aRectangle right).
	self yAxis domain: (Range close: aRectangle top close: aRectangle bottom).! !

!Space2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:20'!
drawAxisOn: aCanvas 

	aCanvas pen: (Pen color: Color black width: 2).
	self drawXLine: (self xAxis mapper map: 0) truncated on: aCanvas.
	self drawYLine: (self yAxis mapper map: 0) truncated on: aCanvas
! !

!Space2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:20'!
drawGridOn: aCanvas 

	aCanvas pen: (Pen color: Color gray).

	self xAxis drawGridLines: #drawXLine:on: for: self on: aCanvas.
	self yAxis drawGridLines: #drawYLine:on: for: self on: aCanvas! !

!Space2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:20'!
drawOn: aCanvas 

	| canvasSave |
	canvasSave := aCanvas save.
	aCanvas erase.
	self drawGridOn: aCanvas.
	self drawAxisOn: aCanvas.
	aCanvas restore: canvasSave
! !

!Space2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:20'!
drawXLine: anInteger on: aCanvas 

	aCanvas 
		moveTo: anInteger @ self viewPortTop;
		lineTo: anInteger @ self viewPortBottom.! !

!Space2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:20'!
drawYLine: anInteger on: aCanvas 

	aCanvas 
		moveTo: self viewPortLeft @ anInteger;
		lineTo: self viewPortRight @ anInteger.! !

!Space2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:20'!
lineFrom: aPoint to: aPoint2 on: aCanvas 

	self 
		moveTo: aPoint on: aCanvas;
		lineTo: aPoint2 on: aCanvas! !

!Space2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:21'!
lineTo: aPoint on: aCanvas 

	aCanvas lineTo: (self mapper map: aPoint) truncated! !

!Space2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:21'!
mappedCanvas
	"This stub method was auto-generated by the Dolphin debugger and remains to be correctly implemented."

	^Error notYetImplemented! !

!Space2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:21'!
mapper

	^RectangleMapper new xMapper: self xAxis mapper; yMapper: self yAxis mapper; yourself! !

!Space2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:22'!
moveTo: aPoint on: aCanvas 

	aCanvas moveTo: (self mapper map: aPoint) truncated! !

!Space2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:23'!
pixelAt: aPoint put: aColor on: aCanvas 

	^aCanvas pixelAt: (self mapper map: aPoint) truncated put: aColor! !

!Space2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:23'!
unitDirectionPointFromAngle: aNumber

	^(self mapper foreRatio * aNumber directionPoint) unit! !

!Space2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:23'!
viewPortBottom

	^self yAxis viewPort stop! !

!Space2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:23'!
viewPortLeft

	^self xAxis viewPort start! !

!Space2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:23'!
viewPortRectangle: aRectangle

	self xAxis viewPort: (aRectangle left to: aRectangle right).
	self yAxis viewPort: (aRectangle top to: aRectangle bottom).
	
! !

!Space2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:23'!
viewPortRight

	^self xAxis viewPort stop! !

!Space2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:23'!
viewPortTop

	^self yAxis viewPort start! !

!Space2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:24'!
xAxis

	xAxis isNil ifTrue: [ self xAxis: SpaceAxis new ].
	^xAxis! !

!Space2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:24'!
xAxis: aSpaceAxis

	xAxis := aSpaceAxis! !

!Space2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:24'!
yAxis

	yAxis isNil ifTrue: [ self yAxis: SpaceAxis new ].
	^yAxis! !

!Space2D methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:24'!
yAxis: aSpaceAxis

	yAxis := aSpaceAxis! !

Object subclass: #SpaceAxis
	instanceVariableNames: 'name mapper domain viewPort tickGap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Plot'!

!SpaceAxis methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 13:51'!
defaultTickGap

	| range commonPower interval |
	range := 
		(Array with: self minimumTickGapInPixels with: self maximumTickGapInPixels) 
			collect: [ :each | self mapper unmapSize: each ].
	commonPower := 10 raisedTo: ((range collect: [:number| number abs ]) min log: 10) asInteger.
	interval :=  [:vector| vector max ceiling to: vector min floor by:-1 ] value: range / commonPower.
	interval := interval reject: [:each| each isZero ].
	
	^(interval detect: [:number| number isNonZeroMultipleOf: 10 ] ifNone: [
	interval detect: [:number| number isNonZeroMultipleOf: 5 ] ifNone: [
	interval detect: [:number| number isNonZeroMultipleOf: 2 ] ifNone: [ interval anyOne ]]]) * commonPower! !

!SpaceAxis methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:25'!
domain

	domain isNil ifTrue: [ self domain: (Range close:-1 close: 1) ].
	^domain! !

!SpaceAxis methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:25'!
domain: aRange

	self mapper: nil.
	domain := aRange! !

!SpaceAxis methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:25'!
domainBoundaryLines: lineClass instanciationMethod: instantiationMethod

	^self domain startAndStop collect: [:each| lineClass perform: instantiationMethod with: each ]! !

!SpaceAxis methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:26'!
drawGridLines: aSymbol for: aSpace2D on: aCanvas 

	self viewPort start = self viewPort stop ifTrue: [ ^self ].
	(self tickGap multipleBiggerThan: (self mapper unmap: self viewPort start)) 
		to: (self tickGap multipleSmallerThan: (self mapper unmap: self viewPort stop)) 
		by: self tickGap 
		do: [:k| aSpace2D perform: aSymbol with: (self mapper map: k) truncated with: aCanvas ].! !

!SpaceAxis methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:26'!
mappedNthTickGap: anInteger 

	^self mapper map: self tickGap * anInteger ! !

!SpaceAxis methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 13:51'!
mapper

	mapper isNil ifTrue: [ self mapper: (RangeMapper from: self domain to: self viewPort) ].
	^mapper! !

!SpaceAxis methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:26'!
mapper: anIntervalMapper

	self tickGap: nil.
	mapper := anIntervalMapper! !

!SpaceAxis methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:26'!
maximumTickGapInPixels

	^80! !

!SpaceAxis methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:27'!
minimumTickGapInPixels

	^30! !

!SpaceAxis methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:27'!
name

	name isNil ifTrue: [ name := 'unnamed!!!!!!!!' ].
	^name! !

!SpaceAxis methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:27'!
name: aString

	name := aString! !

!SpaceAxis methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:27'!
tickGap

	tickGap isNil ifTrue: [ self tickGap: self defaultTickGap ].
	self assert: [ tickGap isZero not ].
	^tickGap! !

!SpaceAxis methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:27'!
tickGap: aNumber

	tickGap := aNumber! !

!SpaceAxis methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:27'!
viewPort

	self assert: [ viewPort notNil ].
	^viewPort! !

!SpaceAxis methodsFor: 'as yet unclassified' stamp: 'hjo 7/25/2008 16:27'!
viewPort: anInterval

	self mapper: nil.
	viewPort := anInterval! !

Object subclass: #SquareSum
	instanceVariableNames: 'a b c d h1 h2 h3 h4 v1 v3 v4 e'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot'!

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:28'!
a

	a isNil ifTrue: [ self a: 1 ].
	^a! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:19'!
a: aNumber

	self h1: nil.
	self h3: nil.
	self h4: nil.
	self v1: nil.
	self v4: nil.
	a := aNumber! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:28'!
b

	b isNil ifTrue: [ self b: 1 ].
	^b! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:21'!
b: aNumber

	self h1: nil.
	self h2: nil.
	self h4: nil.
	self v3: nil.
	self v4: nil.

	b := aNumber! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:28'!
c

	c isNil ifTrue: [ self c: 1 ].
	^c! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:22'!
c: aNumber

	self h1: nil.
	self h2: nil.
	self h3: nil.
	self h4: nil.
	self v1: nil.
	self v3: nil. 

	c := aNumber! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:28'!
d

	d isNil ifTrue: [ self d: 1 ].
	^d! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:23'!
d: aNumber

	self h1: nil.
	self h2: nil.
	self h3: nil.
	self v1: nil.
	self v3: nil.
	self v4: nil.

	d := aNumber! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:17'!
e

	e isNil ifTrue: [ self e: self h1 + self h2 + self h3 + self h4 + self v1 + self v3 + self v4 ].
	^e
! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:06'!
e: aNumber

	e := aNumber! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:07'!
h1

	h1 isNil ifTrue: [ self h1: (self a + self b + self c + self d - 27) squared ].
	^h1
! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:03'!
h1: aNumber
	
	self e: nil.
	h1 := aNumber! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:10'!
h2

	h2 isNil ifTrue: [ self h2: (d + c+ b + b - 21) squared ].
	^h2! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:04'!
h2: aNumber
	
	self e: nil.
	h2 := aNumber! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:11'!
h3

	h3 isNil ifTrue: [ self h3: (c + a + d + a - 27) squared ].
	^h3! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:04'!
h3: aNumber
	
	self e: nil.
	h3 := aNumber! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:12'!
h4

	h4 isNil ifTrue: [ self h4: (a + b + c+ a - 23) squared ].
	^h4! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:04'!
h4: aNumber
	
	self e: nil.
	h4 := aNumber! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:14'!
v1

	v1 isNil ifTrue: [ self v1: (a + d + c + a - 27) squared ].
	^v1
! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:05'!
v1: aNumber
	
	self e: nil.
	v1 := aNumber! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:15'!
v3

	v3 isNil ifTrue: [ self v3: (c + b + d + c - 26) squared ].
	^v3
! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:05'!
v3: aNumber
	
	self e: nil.
	v3 := aNumber! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:16'!
v4

	v4 isNil ifTrue: [ self v4: (d + b + a + a - 22) squared ].
	^v4
! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:05'!
v4: aNumber
	
	self e: nil.
	v4 := aNumber! !

!SquareSum methodsFor: 'variations' stamp: 'hjo 4/7/2008 08:48'!
variationAp

	^self copy
		a: self a + 1! !

!SquareSum methodsFor: 'variations' stamp: 'hjo 4/7/2008 09:18'!
variationBp

	^self copy
		b: self b + 1! !

!SquareSum methodsFor: 'variations' stamp: 'hjo 4/7/2008 09:18'!
variationCp

	^self copy
		c: self c + 1! !

!SquareSum methodsFor: 'variations' stamp: 'hjo 4/7/2008 09:24'!
variationDp

	^self copy
		d: self d + 1! !

!SquareSum methodsFor: 'variations' stamp: 'hjo 4/7/2008 09:55'!
variations

	^self variationsWithDelta: #(1 1 1 1)! !

!SquareSum methodsFor: 'variations' stamp: 'hjo 4/7/2008 09:43'!
variationsWithDelta: anArray 

	^{
		self copy a: (self a + anArray first).
		self copy b: (self b + anArray second).
		self copy c: (self c + anArray third).
		self copy d: (self d + anArray fourth).
	}! !

Object subclass: #StatisticsAgent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Statisticals'!

StatisticsAgent subclass: #Accumulator
	instanceVariableNames: 'sum'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Statisticals'!

!Accumulator methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
countDown

	^self input: -1! !

!Accumulator methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
countUp

	^self input: 1! !

!Accumulator methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
input: aNumber

	sum := self sum + aNumber.! !

!Accumulator methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
reset

	sum := nil! !

!Accumulator methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
sum

	sum isNil ifTrue: [ sum := 0 ].
	^sum! !

!Accumulator methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
sum: aNumber

	sum isNil 
		ifTrue: [  self reset. sum := aNumber  ]
		ifFalse: [  self error: 'Setting sum after use is illigal.' ]
! !

Accumulator subclass: #AverageAgent
	instanceVariableNames: 'count mean'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Statisticals'!

!AverageAgent methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
calculateOutput

	self assert: [ self count isZero not ].
	mean := self sum / self count
	! !

!AverageAgent methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
calculateOutputNoAsserting 

	mean := self count isZero
		ifTrue: [0]
		ifFalse: [self sum / self count]
	! !

!AverageAgent methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
count

	count isNil ifTrue: [ count := 0 ].
	^count! !

!AverageAgent methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
input: aNumber

	super input: aNumber.
	count := self count + 1.
	mean := nil! !

!AverageAgent methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
mean

	mean isNil ifTrue: [ self calculateOutput ].
	^mean! !

!AverageAgent methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
noAssertingMean

	mean isNil ifTrue: [ self calculateOutputNoAsserting ].
	^mean! !

!AverageAgent methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
reset

	super reset.
	count := nil.
! !

AverageAgent subclass: #MeanAndDeviationAgent
	instanceVariableNames: 'squaredSum variance standardDeviation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Statisticals'!

!MeanAndDeviationAgent methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
calculateOutput

	super calculateOutput.
	variance := squaredSum / count - mean squared.
	standardDeviation := variance sqrt! !

!MeanAndDeviationAgent methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
input: aNumber

	super input: aNumber.
	squaredSum := aNumber * aNumber + self squaredSum! !

!MeanAndDeviationAgent methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
reset

	super reset.
	squaredSum := 0! !

!MeanAndDeviationAgent methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
squaredSum

	squaredSum isNil ifTrue: [ squaredSum := 0 ].
	^squaredSum! !

!MeanAndDeviationAgent methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
standardDeviation

	^standardDeviation! !

!MeanAndDeviationAgent methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
variance

	^variance! !

Accumulator subclass: #NonnegativeAccumulator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Statisticals'!

!NonnegativeAccumulator methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
input: aNumber

	self assert: [self sum + aNumber >= 0].
	super input: aNumber! !

!StatisticsAgent methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2008 13:28'!
inputAll: aCollection

	aCollection do: [:object| self input: object ]! !
